//=============================================================================
// Battle.h
//=============================================================================
#pragma once
#include <vector>
#include <assert.h>
#include "Field.h"
#include "CoWndManager.h"
#include "PlayerPartyWindow.h"
#include "EnemyPartyWindow.h"
#include "BattleCmdWindow.h"
#include "BattleCmdSubWindow.h"
#include "BattleInfoWindow.h"
#include "ActionList.h"
#include "BattleCursorManager.h"
#include "Mark.h"

class CEnemy;
class CPlayerChar;
class CManipulator;
//-----------------------------------------------------------------------------
// CBattle
//-----------------------------------------------------------------------------
class CBattle : public CCoWndManager
{
public:
	// EGCgXe[^X
	enum {
		BTL_WAIT_STS_NONE = 0,					// ҂
		BTL_WAIT_STS_PLAYER_ATTACK_ANI,			// v[Aj[V
		BTL_WAIT_STS_PLAYER_ATTACK_BACK_ANI,	// v[߂Aj[V

		BTL_WAIT_STS_ENEMY_ATTACK_ANI,			// GAj[V
	};

private:
	BOOL Create( void ){ assert(0); return FALSE;	};	// don't use

protected:
	int					m_nMode;		// [h (/ʏ/I)
	CField				m_Filed;		// n`
	BATTLE_PARAM		m_Param;		// p[^

	std::vector<CEnemy *>		m_lstEnemy;		// GXg
	CActionList					m_ActList;

	CBattleCursorManager		m_CursorMan;	// J[\ǗNX
	CMark						m_Mark;			// v[}[N

	std::list<int>		m_lstCmdInput;		// v[R}h͏Ǘ

	BOOL				m_bEnemySelecting;	// GI
	BOOL				m_bPlayerSelecting;	// I

	int					m_nMarkIndex;		// ݑ쒆̃v[

	int					m_nPlayerWaitStatus;	// ҂Ă邩
	int					m_nEnemyWaitStatus;	// ҂Ă邩

	int					m_nCommandID;		// ݕ\̃R}h
	int					m_nActor;			// ݕ\̃R}hM
	int					m_nTarget;			// ݕ\̃R}h^[Qbg
	int					m_nParam1;			// ݕ\̃R}hp[^
	int					m_nParam2;			// ݕ\̃R}hp[^


	// qEBhE
	CPlayerPartyWindow		m_PlayerPartyWnd;
	CEnemyPartyWindow		m_EnemyPartyWnd;
	CBattleCmdWindow		m_CmdWnd;
	CBattleCmdSubWindow		m_SubWnd;
	CBattleInfoWindow		m_InfoWnd;

	// G̍폜
	void RemoveAllEnemies( void );

	// [h̓
	void FrameMoveModeBattle( const CManipulator *pMani );
	void FrameMoveModeWon( const CManipulator *pMani );
	void FrameMoveModeLose( const CManipulator *pMani );
	void FrameMoveModeEscape( const CManipulator *pMani );

	// _[WvZ
	int CalcAttackDamage( int nCommandID, CPlayerChar *pPlayer, CEnemy *pEnemy );

	// ΏۓGI
	int AutoSelectEnemyTarget( void );

	// SŃ`FbN
	BOOL IsWon( void );
	void SetWinInfo( void );

	BOOL IsLose( void );

	// R}h͏Xgǉ
	void AddCmdInputList( int nPlayerIndex );
	// R}h͏Xg擾
	int GetActionablePlayer( void );

public:
	CBattle(void);
	virtual ~CBattle(void);

	// 
	BOOL Create( BATTLE_PARAM *pParam );
	// I
	void Delete( void );
	// XV
	void FrameMove( const CManipulator *pMani );
	// `
	void Render( void );

	void SetVisible( BOOL bFlag );

	void DoPlayerAction( TIMEKEEP_INFO *pInfo );
	void DoEnemyAction( TIMEKEEP_INFO *pInfo );

	// qEBhẼj[ʒm
	virtual void NotifyDecideKey( CFrameWindow *pWnd, int nCmdID );

	// qEBhẼLZ{^ʒm
	virtual void NotifyCancelKey( CFrameWindow *pWnd );

	// CR}hEBhẺEL[
	void NotifyRightKey( CFrameWindow *pWnd );
	// TuR}hEBhẺEL[
	void NotifyLeftKey( CFrameWindow *pWnd );
};

