//=============================================================================
// BattleCmdSubWindow.cpp
//=============================================================================
#include "Stdinc.h"
#include "BattleCmdSubWindow.h"
#include "DataManager.h"
#include "Manipulator.h"
#include "Battle.h"
//-----------------------------------------------------------------------------
// RXgN^
//-----------------------------------------------------------------------------
CBattleCmdSubWindow::CBattleCmdSubWindow(void)
{
}

//-----------------------------------------------------------------------------
// fXgN^
//-----------------------------------------------------------------------------
CBattleCmdSubWindow::~CBattleCmdSubWindow(void)
{
}

//-----------------------------------------------------------------------------
// Create
//-----------------------------------------------------------------------------
BOOL CBattleCmdSubWindow::Create( int iPosX, int iPosY, int iWidth, int iHeight, CBattle *pParent )
{
	m_pParent = pParent;

	BOOL bRet = CMenuWindow::Create( iPosX, iPosY, iWidth, iHeight );

	ClearMenuItem();

	const int SUB_CMD_ID[] = {
		COMMAND_ID_GUARD, COMMAND_ID_PASS, COMMAND_ID_CHANGE

	};

	for ( int iCnt = 0; iCnt < sizeof(SUB_CMD_ID)/sizeof(SUB_CMD_ID[0]); iCnt ++ )
	{
		if ( SUB_CMD_ID[iCnt] != COMMAND_ID_NONE )
		{
			int nPosY = 15 * iCnt + 8;
			const char *lpzText = CDataManager::GetInstance()->GetCommandText( SUB_CMD_ID[iCnt] );
			AddMenuItem( SUB_CMD_ID[iCnt], TRUE, 10, nPosY, lpzText, 0, 0 );
		}
	}
	return bRet;
}
//-----------------------------------------------------------------------------
// FrameMove
//-----------------------------------------------------------------------------
void CBattleCmdSubWindow::FrameMove( const CManipulator *pMani )
{
	if ( !m_bFocused )
		return;
	if ( !IsVisible() )
		return;

	int nLastCurPos = GetCurPos();
	CMenuWindow::FrameMove( pMani );

	// EL[
	if ( pMani->CheckKey( KEY_INPUT_LEFT ) )
	{
		m_pParent->NotifyLeftKey( this );
	}
	// LZL[
	else if ( pMani->CheckKey( KEY_INPUT_Z ) )
	{
		m_pParent->NotifyCancelKey( this );
	}
	// L[
	else if ( pMani->CheckKey( KEY_INPUT_X ) )
	{
		if ( !m_bFocused )
			return;
		stMenuItem *pItem = m_aryItem.at( GetCurPos() );
		// R}hIDʒm
		m_pParent->NotifyDecideKey( this, pItem->nID );
	}
}
//-----------------------------------------------------------------------------
// Render
//-----------------------------------------------------------------------------
void CBattleCmdSubWindow::Render( void )
{
	if ( !IsVisible() )
		return;

	CMenuWindow::Render();
}