//=============================================================================
// BattleCmdWindow.cpp
//=============================================================================
#include "Stdinc.h"
#include "BattleCmdWindow.h"
#include "DataManager.h"
#include "Manipulator.h"
#include "Battle.h"
//-----------------------------------------------------------------------------
// RXgN^
//-----------------------------------------------------------------------------
CBattleCmdWindow::CBattleCmdWindow(void)
{
}

//-----------------------------------------------------------------------------
// fXgN^
//-----------------------------------------------------------------------------
CBattleCmdWindow::~CBattleCmdWindow(void)
{
}
//-----------------------------------------------------------------------------
// AddCommand
//-----------------------------------------------------------------------------
void CBattleCmdWindow::AddCommand( const int *pCommandID )
{

	ClearMenuItem();

	for ( int iCnt = 0; iCnt < PLAYER_COMMAND_MAX; iCnt ++ )
	{
		if ( pCommandID[iCnt] != COMMAND_ID_NONE )
		{
			int nPosY = 15 * iCnt + 8;
			const char *lpzText = CDataManager::GetInstance()->GetCommandText( pCommandID[iCnt] );
			AddMenuItem( pCommandID[iCnt], TRUE, 10, nPosY, lpzText, 0, 0 );
		}
	}
}
//-----------------------------------------------------------------------------
// Create
//-----------------------------------------------------------------------------
BOOL CBattleCmdWindow::Create( int iPosX, int iPosY, int iWidth, int iHeight, CBattle *pParent )
{
	m_pParent = pParent;

	return CMenuWindow::Create( iPosX, iPosY, iWidth, iHeight );
}
//-----------------------------------------------------------------------------
// FrameMove
//-----------------------------------------------------------------------------
void CBattleCmdWindow::FrameMove( const CManipulator *pMani )
{
	if ( !m_bFocused )
		return;

	if ( !IsVisible() )
		return;

	int nLastCurPos = GetCurPos();
	CMenuWindow::FrameMove( pMani );

	// EL[
	if ( pMani->CheckKey( KEY_INPUT_RIGHT ) )
	{
		m_pParent->NotifyRightKey( this );
	}

	// LZL[
	else if ( pMani->CheckKey( KEY_INPUT_Z ) )
	{
		m_pParent->NotifyCancelKey( this );
	}
	// L[
	else if ( pMani->CheckKey( KEY_INPUT_X ) )
	{
		if ( !m_bFocused )
			return;
		stMenuItem *pItem = m_aryItem.at( GetCurPos() );
		// R}hIDʒm
		m_pParent->NotifyDecideKey( this, pItem->nID );
	}
}
//-----------------------------------------------------------------------------
// Render
//-----------------------------------------------------------------------------
void CBattleCmdWindow::Render( void )
{
	if ( !IsVisible() )
		return;

	CMenuWindow::Render();
}