//=============================================================================
// BattleInfoWindow.cpp
//=============================================================================
#include "Stdinc.h"
#include "BattleInfoWindow.h"
#include "Manipulator.h"

//-----------------------------------------------------------------------------
// RXgN^
//-----------------------------------------------------------------------------
CBattleInfoWindow::CBattleInfoWindow(void)
	:m_nWinState( WIN_STATE_NONE )
{
}

//-----------------------------------------------------------------------------
// fXgN^
//-----------------------------------------------------------------------------
CBattleInfoWindow::~CBattleInfoWindow(void)
{
	for ( int iCnt = 0; iCnt < (int)m_aryMsgList.size(); iCnt ++ )
	{
		char *pMessage = m_aryMsgList.front();
		delete [] pMessage;
		m_aryMsgList.pop_front();
	}
}
//-----------------------------------------------------------------------------
// Create
//-----------------------------------------------------------------------------
BOOL CBattleInfoWindow::Create( int iPosX, int iPosY, int iWidth, int iHeight )
{
	return CMsgWindow::Create( iPosX, iPosY, iWidth, iHeight );
}
//-----------------------------------------------------------------------------
// Render
//-----------------------------------------------------------------------------
void CBattleInfoWindow::Render( void )
{
	if ( !m_bIsVisible )
		return ;

	CMsgWindow::Render();
}
//-----------------------------------------------------------------------------
// FrameMove
//-----------------------------------------------------------------------------
void CBattleInfoWindow::FrameMove( const CManipulator *pMani )
{
	if ( m_nWinState == WIN_STATE_MESSAGE && (pMani->CheckKey( KEY_INPUT_X ) || pMani->CheckKey( KEY_INPUT_Z )) )
	{
		if ( m_aryMsgList.size() == 0 )
		{	// bZ[W
			SetVisible( FALSE );
		}
		else
		{	// bZ[W
			char *pMessage = m_aryMsgList.front();
			SetMessage( pMessage );	// bZ[Wݒ
			delete [] pMessage;
			m_aryMsgList.pop_front();
		}

	}
}
//-----------------------------------------------------------------------------
// SetWinInfo
//-----------------------------------------------------------------------------
void CBattleInfoWindow::SetWinInfo( int nGill, int nExp, int nABP, std::list<char *> &aryApendMsg  )
{
	m_nWinState = WIN_STATE_MESSAGE;	// 킢ɏI
	m_nDispLine = 0;

	m_nGill = nGill;
	m_nExp = nExp;
	m_nABP = nABP;

	char *pMessage;
	// 킢ɏI
	SetMessage( "킢ɏI" );
	// EXP
	if ( 0 < m_nExp )
	{
		pMessage = new char [DISPLAY_MESSAGE_LEN_MAX];
		sprintf_s( pMessage, DISPLAY_MESSAGE_LEN_MAX, "%d EXP", m_nExp );
		m_aryMsgList.push_back( pMessage );
	}
	// M
	if ( 0 < m_nGill )
	{
		pMessage = new char [DISPLAY_MESSAGE_LEN_MAX];
		sprintf_s( pMessage, DISPLAY_MESSAGE_LEN_MAX, "%d M", m_nGill );
		m_aryMsgList.push_back( pMessage );
	}
	// ABP
	if (  0 < m_nABP )
	{
		pMessage = new char [DISPLAY_MESSAGE_LEN_MAX];
		sprintf_s( pMessage, DISPLAY_MESSAGE_LEN_MAX, "%d ABP", m_nABP );
		m_aryMsgList.push_back( pMessage );
	}
	// ǉRs[
	if ( aryApendMsg.size() )
		m_aryMsgList.merge( aryApendMsg );
}
