//=============================================================================
// CampMenuWindow.cpp
//=============================================================================
#include "Stdinc.h"
#include "Cursor.h"
#include "CampMenuWindow.h"
#include "Manipulator.h"
#include "CampWindow.h"

const stMenuItem CAMP_MENU_ITEM[] = {
	{   CCampMenuWindow::MENU_ID_ITEM,	TRUE,	8,   8, "ACe", 0, 0 },
	{   CCampMenuWindow::MENU_ID_MAGIC,	TRUE,	8,  26, "܂ق", 0, 0 },
	{   CCampMenuWindow::MENU_ID_EQUIP,	TRUE,	8,  44, "", 0, 0 },
	{   CCampMenuWindow::MENU_ID_STATUS,  TRUE,	8,  62, "Xe[^X", 0, 0 },
	{   CCampMenuWindow::MENU_ID_CONFIG,  TRUE,	8,  80, "RtBO", 0, 0 },
	{   CCampMenuWindow::MENU_ID_SAVE,	TRUE,	8,  98, "Z[u", 0, 0 },
};

//-----------------------------------------------------------------------------
// RXgN^
//-----------------------------------------------------------------------------
CCampMenuWindow::CCampMenuWindow(void)
	: m_bEnabled( TRUE ), m_bSelected( FALSE )
{
	m_nType = MENU_TYPE_VERTICAL;	// c^j[
}

//-----------------------------------------------------------------------------
// fXgN^
//-----------------------------------------------------------------------------
CCampMenuWindow::~CCampMenuWindow(void)
{
}


//-----------------------------------------------------------------------------
// Create
//-----------------------------------------------------------------------------
BOOL CCampMenuWindow::Create( int iPosX, int iPosY, int iWidth, int iHeight, CCampWindow *pParent )
{
	// eEBhEۑ
	m_pCampWnd = pParent;

	BOOL bRet = CMenuWindow::Create( iPosX, iPosY, iWidth, iHeight );

	// ACeǉ
	for ( int iCnt = 0; iCnt < sizeof( CAMP_MENU_ITEM ) / sizeof( CAMP_MENU_ITEM[0] ); iCnt ++ )
	{
		AddMenuItem( &CAMP_MENU_ITEM[iCnt] );
	}
	return bRet;
}
//-----------------------------------------------------------------------------
// `
//-----------------------------------------------------------------------------
void CCampMenuWindow::Render( void )
{
	CMenuWindow::Render();

	if ( !m_bEnabled )
	{	// Â
		SetDrawBlendMode( DX_BLENDMODE_ALPHA, 96 );
		DrawBox( m_nPosX, m_nPosY, m_nPosX + m_nWidth, m_nPosY + m_nHeight, GetColor(0,0,0), TRUE );
		SetDrawBlendMode( DX_BLENDMODE_NOBLEND, 255 );
	}


	// I_ŃJ[\`
	// (tH[JXɂ`悷)
	if ( m_bSelected )
	{
		m_pCursor->RenderSelectedCursor();
	}
}
//-----------------------------------------------------------------------------
// XV
//-----------------------------------------------------------------------------
void CCampMenuWindow::FrameMove( const CManipulator *pMani )
{
	if ( !IsFocused() )
		return;

	CMenuWindow::FrameMove( pMani );

	if ( pMani->CheckKey( KEY_INPUT_Z ) )
	{
		if ( m_bSelected )
		{	// I𒆂ȂI
			m_bSelected = FALSE;
		}
		else
		{	// I𒆈ȊOȂeEBhEŃLZ
			m_pCampWnd->NotifyCancelKey( this );
		}
	}
	else if ( pMani->CheckKey( KEY_INPUT_X ) )
	{
		if ( GetCurPos() == CCampMenuWindow::MENU_ID_MAGIC ||
			 GetCurPos() == CCampMenuWindow::MENU_ID_EQUIP ||
			 GetCurPos() == CCampMenuWindow::MENU_ID_STATUS )
		{	// 
			if ( !m_bSelected )
			{	// 
				m_bSelected = TRUE;
				m_nSelItem = GetCurPos();
				// IJ[\`ʒuǉ
				stMenuItem *pItem = GetItem( GetCurPos() );
				m_pCursor->AddSelectedPos( m_nPosX + pItem->nPosX-12, m_nPosY + pItem->nPosY-3 );

				// p[eBEBhEɃtH[JX
				m_pCampWnd->SelectPartyMemberReq();

			}
		}
		else
		{	// IĂ
			UnSelectItem();
			m_pCampWnd->NotifyDecideKey( this, GetCurPos() );
		}
	}
}
//-----------------------------------------------------------------------------
// UnSelectItem
//-----------------------------------------------------------------------------
void CCampMenuWindow::UnSelectItem( void )
{
	m_pCursor->RemoveAllSelectedPos();	// IԏI
	m_bSelected = FALSE;
}
