//=============================================================================
// ChoiceMsgWindow.cpp
//=============================================================================
#include "Stdinc.h"
#include "ChoiceMsgWindow.h"
#include "Manipulator.h"

const stMenuItem ITEM_CHOICE[] = {
	{   CChoiceMsgWindow::MENU_ID_ITEM_1,		TRUE,   10,  25, "", 0, 0 },
	{   CChoiceMsgWindow::MENU_ID_ITEM_2,		TRUE,   10,  40, "", 0, 0 },
	{   CChoiceMsgWindow::MENU_ID_ITEM_3,		TRUE,   10,  55, "", 0, 0 },
};
//-----------------------------------------------------------------------------
// RXgN^
//-----------------------------------------------------------------------------
CChoiceMsgWindow::CChoiceMsgWindow(void)
	:m_nChooseAns( MENU_ID_ITEM_1 )
{
	CMenuWindow::m_nType = MENU_TYPE_VERTICAL;	// c^j[
}

//-----------------------------------------------------------------------------
// fXgN^
//-----------------------------------------------------------------------------
CChoiceMsgWindow::~CChoiceMsgWindow(void)
{
}
//-----------------------------------------------------------------------------
// Create
//-----------------------------------------------------------------------------
BOOL CChoiceMsgWindow::Create( int iPosX, int iPosY, int iWidth, int iHeight )
{
	BOOL bRet = CMenuWindow::Create( iPosX, iPosY, iWidth, iHeight );


	return bRet;
}

//-----------------------------------------------------------------------------
// Render
//-----------------------------------------------------------------------------
void CChoiceMsgWindow::Render( void )
{
	if ( !IsVisible() )
		return;

	CMenuWindow::Render();

	// \
	for ( int iCnt = 0; iCnt < QUESTION_MESSAGE_LINE_MAX; iCnt ++ )
	{
		int iPosY = m_nPosY + FRAME_TO_STRING_MARGINE_Y + ( iCnt * (DISPLAY_MESSAGE_FONT_SIZE + 4) );

		DrawString( m_nPosX + FRAME_TO_STRING_MARGINE_X, iPosY, m_szDisplayMsg[iCnt], STRING_COLOR );
	}
}
//-----------------------------------------------------------------------------
// FrameMove
//-----------------------------------------------------------------------------
void CChoiceMsgWindow::FrameMove( const CManipulator *pMani )
{
	if ( !m_bFocused )
		return;

	CMenuWindow::FrameMove( pMani );

	// LZL[
	if ( pMani->CheckKey( KEY_INPUT_Z ) )
	{
		m_nChooseAns = ANSWER_NO;
		SetFocus( FALSE );
		SetVisible( FALSE );
	}
	else if ( pMani->CheckKey( KEY_INPUT_X ) )
	{
		m_nChooseAns = GetCurPos() + 1;
		SetFocus( FALSE );
		SetVisible( FALSE );
	}
}
//-----------------------------------------------------------------------------
// SetVisible
//-----------------------------------------------------------------------------
void CChoiceMsgWindow::SetVisible( BOOL bFlag )
{
	CMenuWindow::SetVisible( bFlag );
	if ( bFlag )
	{
		SetFocus( TRUE );
		SetCurPos( 0 );
	}
}
//-----------------------------------------------------------------------------
// SetQuestionMessage
//-----------------------------------------------------------------------------
void CChoiceMsgWindow::SetQuestionMessage( const char *lpzQuestion, const char *lpzAns1, const char *lpzAns2, const char *lpzAns3 )
{
	// bZ[Wۑobt@ɃRs[
	m_nLineCnt = DivCopyToMsgBuf( lpzQuestion );

	// \obt@ɃRs[
	for ( int iCnt = 0; iCnt < QUESTION_MESSAGE_LINE_MAX; iCnt ++ )
	{
		strcpy_s( m_szDisplayMsg[iCnt], _countof(m_szDisplayMsg[iCnt]), m_szMsg[iCnt] );
	}

	ClearMenuItem();

	// j[ACeǉ
	if ( !lpzAns3 || strlen( lpzAns3 ) == 0 )
	{	// I2o[W
		for ( int iCnt = 0; iCnt < 2; iCnt ++ )
		{
			AddMenuItem( &ITEM_CHOICE[iCnt+1] );
		}
		UpdateMenuText( MENU_ID_ITEM_1, TRUE, lpzAns1, 0, 0 );
		UpdateMenuText( MENU_ID_ITEM_2, TRUE, lpzAns2, 0, 0 );
	}
	else
	{	// I3o[W
		for ( int iCnt = 0; iCnt < sizeof( ITEM_CHOICE ) / sizeof( ITEM_CHOICE[0] ); iCnt ++ )
		{
			AddMenuItem( &ITEM_CHOICE[iCnt] );
		}
		UpdateMenuText( MENU_ID_ITEM_1, TRUE, lpzAns1, 0, 0 );
		UpdateMenuText( MENU_ID_ITEM_2, TRUE, lpzAns2, 0, 0 );
		UpdateMenuText( MENU_ID_ITEM_3, TRUE, lpzAns3, 0, 0 );
	}

}

//-----------------------------------------------------------------------------
// CopyWidthLimitString
//-----------------------------------------------------------------------------
int CChoiceMsgWindow::CopyWidthLimitString( char *pDst, const char *pSrc, int nLen )
{
	strncpy_s( pDst, nLen, pSrc, nLen );

	int iStrLen = strlen(pDst);
	for ( int iCnt = iStrLen; 0 < iCnt; iCnt -- )
	{
		int iStrWidth = GetDrawStringWidth( pDst, iStrLen );
		if ( m_nWidth < iStrWidth + FRAME_TO_STRING_MARGINE_X * 2 )
		{	// Eɂ͂ݏoȂ1
			pDst[iCnt] = '\0';
		}
	}

	return 0;
}
//-----------------------------------------------------------------------------
// DivCopyToMsgBuf
//-----------------------------------------------------------------------------
int CChoiceMsgWindow::DivCopyToMsgBuf( const char *pSrc, int nLineCnt /* = 0 */ )
{
	if ( nLineCnt == 0 )
	{
		RtlZeroMemory( m_szMsg, sizeof(m_szMsg) );
	}

	// '\' + 'n' ̕ '\n' ɒu
	char szReplaceBuff[1024];
	CSysUtil::ReplaceString( szReplaceBuff, sizeof(szReplaceBuff), pSrc, "\\n", "\n" );

//	int nLineCnt = 0;
	const char *pStart = szReplaceBuff;
	const char *pPtr = strstr( szReplaceBuff, "\n" );

	while ( pPtr )
	{
		char szBuff[DISPLAY_MESSAGE_LEN_MAX];
		strncpy_s( szBuff, pStart, (size_t)(pPtr - pStart) );

		CopyWidthLimitString( m_szMsg[nLineCnt], szBuff, _countof(m_szMsg[nLineCnt])-1 );

		nLineCnt++;
		pStart = pPtr+1;
		pPtr = strstr( pPtr+1, "\n" );
	}

	CopyWidthLimitString( m_szMsg[nLineCnt], pStart, _countof(m_szMsg[nLineCnt])-1 );

	return nLineCnt+1;
}