//=============================================================================
// CoWndManager.cpp
//=============================================================================
#include "Stdinc.h"
#include "CoWndManager.h"
#include "FrameWindow.h"
#include "MenuWindow.h"
#include "Manipulator.h"

//-----------------------------------------------------------------------------
// RXgN^
//-----------------------------------------------------------------------------
CCoWndManager::CCoWndManager(void)
	:m_pWndLastFocused( NULL ), m_pNewFocusWnd( NULL )
{
}

//-----------------------------------------------------------------------------
// fXgN^
//-----------------------------------------------------------------------------
CCoWndManager::~CCoWndManager(void)
{
}
//-----------------------------------------------------------------------------
// XV
//-----------------------------------------------------------------------------
void CCoWndManager::FrameMove( const CManipulator *pMani )
{
	using namespace std;

	// CoEBhEXV
	list<CFrameWindow *>::iterator it = m_lstCoWindow.begin();
	while( it != m_lstCoWindow.end() )
	{
		if ( (*it)->IsMenu() )
			((CMenuWindow*)(*it))->FrameMove( pMani );
		else
			(*it)->FrameMove();
		++it;
	}

	// tH[JXύXNGXg΍XV
	if ( m_pNewFocusWnd )
	{
		it = m_lstCoWindow.begin();
		while( it != m_lstCoWindow.end() )
		{
			if ( (*it)->IsMenu() )
			{
				((CMenuWindow*)(*it))->SetFocus( FALSE );
			}
			++it;
		}
		m_pNewFocusWnd->SetFocus( TRUE );
		m_pNewFocusWnd = NULL;
	}
}
//-----------------------------------------------------------------------------
// `
//-----------------------------------------------------------------------------
void CCoWndManager::Render( void )
{
	using namespace std;

	// CoEBhE`
	list<CFrameWindow *>::iterator it = m_lstCoWindow.begin();
	while( it != m_lstCoWindow.end() )
	{
		(*it)->Render();
		++it;
	}
}
//-----------------------------------------------------------------------------
// SetVisible
//-----------------------------------------------------------------------------
void CCoWndManager::SetVisible( BOOL bFlag )
{
	CDrawable::SetVisible( bFlag );

	using namespace std;
	// CoEBhE`
	list<CFrameWindow *>::iterator it = m_lstCoWindow.begin();
	while( it != m_lstCoWindow.end() )
	{
		(*it)->SetVisible( bFlag );
		++it;
	}
};
//-----------------------------------------------------------------------------
// ChangeFocus
//-----------------------------------------------------------------------------
void CCoWndManager::ChangeFocus( CMenuWindow *pNewFocusWnd )
{
	m_pNewFocusWnd = pNewFocusWnd;

	// J[\ʒuݒ
	m_pNewFocusWnd->SetCurPos( m_pNewFocusWnd->GetCurPos() );
}
