//=============================================================================
// DataManager.cpp
//=============================================================================
#include "Stdinc.h"
#include "DataManager.h"
#include "MapManager.h"
#include "MapObject.h"
#include "MapEvent.h"
#include "CSVString.h"
#include "Item.h"
#include "Enemy.h"

//-----------------------------------------------------------------------------
// RXgN^
//-----------------------------------------------------------------------------
CDataManager::CDataManager(void)
:m_bLoadedMapChipGraph( FALSE ), m_bLoadedCharacterGraph( FALSE ), m_bLoadedFrameWndGraph( FALSE )
{
}

//-----------------------------------------------------------------------------
// fXgN^
//-----------------------------------------------------------------------------
CDataManager::~CDataManager(void)
{
	for ( int iCnt = 0; iCnt < (int)m_aryAniChipInfo.size(); iCnt ++ )
	{
		stAniChipInfo *pInfo = m_aryAniChipInfo.at( iCnt );
		delete pInfo;
	}
}
//-----------------------------------------------------------------------------
// GetInstance
//-----------------------------------------------------------------------------
CDataManager *CDataManager::GetInstance( void )
{
	static CDataManager m_Instance;
	return &m_Instance;
}
//-----------------------------------------------------------------------------
// LoadMap
//-----------------------------------------------------------------------------
BOOL CDataManager::LoadMap( int nMapID, CMapManager *pMap )
{
	using namespace std;

	char szMapFileName[MAX_PATH];
	RtlZeroMemory( szMapFileName, sizeof(szMapFileName) );


	// IDΉ }bv擾
	char szFileName[MAX_PATH], szLine[1024], wkBuff[1024];
	int	nLoopAtEdge = 0;
	int nIsEncount = 0;
	FILE *fp;
	BOOL bRet = TRUE;

	sprintf_s( szFileName, sizeof(szFileName), "%s\\%s", MAP_DATA_DIR, MAP_INFO_CSV_FILE_NAME );
	//  MapInfo.csv
	if ( fopen_s( &fp, szFileName, "r" ) != 0 )
	{
		CSysUtil::Msg("t@Cǂݍݎs [%s]", szFileName);
		return FALSE;
	}
	// 1,2sڂ xs
	fgets( szLine, sizeof(szLine), fp );
	fgets( szLine, sizeof(szLine), fp );

	// 3sڂf[^
	BOOL bFound = FALSE;
	int nChipID[LAYER_CHIP_MAX];	// CChipG
	while ( fgets( szLine, sizeof(szLine), fp ) )
	{
		LPCSTR pPtr = szLine;

		// ID
		int nID = CCSVString::GetNextInt( pPtr );
		if ( nID != nMapID )
			continue;

		// 
		bFound = TRUE;

		// [vtO
		nLoopAtEdge = CCSVString::GetNextInt( pPtr );

		// Go邩
		nIsEncount = CCSVString::GetNextInt( pPtr );

		// }bvt@C
		CCSVString::GetNextString( wkBuff, sizeof(wkBuff), pPtr );
		sprintf_s( szMapFileName, sizeof(szMapFileName), "%s\\%s", MAP_DATA_DIR, wkBuff );

		nChipID[LAYER_0] = CCSVString::GetNextInt( pPtr );
		nChipID[LAYER_1] = CCSVString::GetNextInt( pPtr );
		nChipID[LAYER_2] = CCSVString::GetNextInt( pPtr );
		break;
	}
	fclose( fp );

	if ( !bFound )
	{	return FALSE; }


	// }bvt@CǍ
	int nFileHandle = FileRead_open( szMapFileName );
	if ( nFileHandle == DX_INVALID_HANDLE )
	{
		return FALSE;
	}

	// wb_Ǎ
	FMFHEADER fmfHeader;
	if ( FileRead_read( &fmfHeader, sizeof(fmfHeader), nFileHandle ) == DX_FAILED )
	{
		FileRead_close( nFileHandle );
		return FALSE;
	}

	// C
	if ( LAYER_MAX < fmfHeader.byLayerCount )
	{
		FileRead_close( nFileHandle );
		return FALSE;
	}

	// }bvݒ
	pMap->SetMapInfo( fmfHeader.dwWidth, fmfHeader.dwHeight, nChipID, (BOOL)nLoopAtEdge, (BOOL)nIsEncount );

	// `bv̈m
	WORD **pMapChip = pMap->GetMapChip();
	int iReadCnt = fmfHeader.dwWidth * fmfHeader.dwHeight;
	for ( int iLayer = 0; iLayer < LAYER_CHIP_MAX; iLayer ++ )
	{
		pMapChip[iLayer] = new WORD[iReadCnt];
		RtlZeroMemory( pMapChip[iLayer], sizeof(WORD) * iReadCnt );
		if ( FileRead_read( pMapChip[iLayer], sizeof(WORD) * iReadCnt, nFileHandle ) == DX_FAILED )
		{
			FileRead_close( nFileHandle );
			return FALSE;
		}
	}

	// ʍs/s擾
	pMap->m_wPassFlag = new WORD[iReadCnt];
	RtlZeroMemory( pMap->m_wPassFlag, sizeof(WORD) * iReadCnt );
	if ( FileRead_read( pMap->m_wPassFlag, sizeof(WORD) * iReadCnt, nFileHandle ) == DX_FAILED )
	{
		FileRead_close( nFileHandle );
		return FALSE;
	}

	// }bvIuWFNg擾
	pMap->m_MapEvent.m_wMapObject = new WORD[iReadCnt];
	RtlZeroMemory( pMap->m_MapEvent.m_wMapObject, sizeof(WORD) * iReadCnt );
	if ( FileRead_read( pMap->m_MapEvent.m_wMapObject, sizeof(WORD) * iReadCnt, nFileHandle ) == DX_FAILED )
	{
		FileRead_close( nFileHandle );
		return FALSE;
	}

	// () GJEg擾
	pMap->m_wEncountFlag = new WORD[iReadCnt];
	RtlZeroMemory( pMap->m_wEncountFlag, sizeof(WORD) * iReadCnt );
	if ( FileRead_read( pMap->m_wEncountFlag, sizeof(WORD) * iReadCnt, nFileHandle ) == DX_FAILED )
	{
		FileRead_close( nFileHandle );
		return TRUE;
	}

	FileRead_close( nFileHandle );

	return TRUE;
}


//-----------------------------------------------------------------------------
// LoadMapChipGraph
// S}bv`bvǍ
//-----------------------------------------------------------------------------
BOOL CDataManager::LoadMapChipGraph( std::map<int, int> &mapInfo )
{
	if ( m_bLoadedMapChipGraph )
	{
		return TRUE;
	}
	using namespace std;
	char szFileName[MAX_PATH], szLine[1024], wkBuff[1024];
	FILE *fp;
	BOOL bRet = TRUE;

	sprintf_s( szFileName, sizeof(szFileName), "%s\\%s", MAP_DATA_DIR, MAPCHIP_INFO_CSV_FILE_NAME );
	//  MapChipInfo.csv
	if ( fopen_s( &fp, szFileName, "r" ) != 0 )
	{
		CSysUtil::Msg("t@Cǂݍݎs [%s]", szFileName);
		return FALSE;
	}
	// 1,2sڂ xs
	fgets( szLine, sizeof(szLine), fp );
	fgets( szLine, sizeof(szLine), fp );

	// 3sڂf[^
	while ( fgets( szLine, sizeof(szLine), fp ) )
	{
		LPCSTR pPtr = szLine;

		// ID
		int nID = CCSVString::GetNextInt( pPtr );
		// O
		CCSVString::GetNextString( wkBuff, sizeof(wkBuff), pPtr );

		// `bvt@Cǂݍ
		SetTransColor(  0,117,117 );
		sprintf_s( szFileName, sizeof(szFileName), "%s\\%s", MAP_DATA_DIR, wkBuff );
		int nHandle = ::LoadGraph( szFileName );
		if ( nHandle == DX_FAILED )
		{
			CSysUtil::Msg("摜ǂݍݎs [%s]", szFileName );
			return FALSE;
		}
		m_aryHandleMapChip.push_back( nHandle );
		mapInfo.insert( pair<int, int>( nID, nHandle ));

	}
	fclose( fp );

	// Aj[V`bv쐬
	bRet &= CreateAnimationChipGraph( mapInfo );

	m_bLoadedMapChipGraph = bRet;

	return bRet;
}
//-----------------------------------------------------------------------------
// CreateAnimationChipGraph
// Aj[V`bv쐬
//-----------------------------------------------------------------------------
BOOL CDataManager::CreateAnimationChipGraph( std::map<int, int> &mapInfo )
{
	using namespace std;

	char szFileName[MAX_PATH], szLine[1024];
	FILE *fp;
	BOOL bRet = TRUE;

	sprintf_s( szFileName, sizeof(szFileName), "%s\\%s", MAP_DATA_DIR, ANICHIP_INFO_CSV_FILE_NAME );
	//  AniChipInfo.csv
	if ( fopen_s( &fp, szFileName, "r" ) != 0 )
	{
		CSysUtil::Msg("t@Cǂݍݎs [%s]", szFileName);
		return FALSE;
	}
	// 1,2sڂ xs
	fgets( szLine, sizeof(szLine), fp );
	fgets( szLine, sizeof(szLine), fp );

	// 3sڂf[^
	while ( fgets( szLine, sizeof(szLine), fp ) )
	{
		LPCSTR pPtr = szLine;

		stAniChipInfo *pInfo = new stAniChipInfo;
		RtlZeroMemory( pInfo, sizeof(stAniChipInfo) );
		m_aryAniChipInfo.push_back( pInfo );

		// `bvID
		pInfo->nChipID = CCSVString::GetNextInt( pPtr );
		// `bvԍ
		pInfo->nChipNo = CCSVString::GetNextInt( pPtr );
		// Aj[V^Cv
		pInfo->nAniType = CCSVString::GetNextInt( pPtr );

		// 摜擾
		int iSrcPosX = (pInfo->nChipNo % 0x100) * MAP_CHIP_SIZE;
		int iSrcPosY = (pInfo->nChipNo / 0x100) * MAP_CHIP_SIZE;

		map<int, int>::iterator itlMap;
		itlMap = mapInfo.find( pInfo->nChipID );
		if ( itlMap == mapInfo.end() )
		{
			return FALSE;
		}

		// IWiG擾
		int nHdlOrgGraph = DerivationGraph( iSrcPosX, iSrcPosY, MAP_CHIP_SIZE, MAP_CHIP_SIZE, itlMap->second ) ;
		int nSrcGraph = nHdlOrgGraph;
		int nDivLine = 0;
		for ( int iCntFrame = 0; iCntFrame < CHIP_ANIMATION_FRAME; iCntFrame ++ )
		{
			// LoX쐬
			pInfo->nAniGraphHandle[iCntFrame] = MakeGraph( MAP_CHIP_SIZE, MAP_CHIP_SIZE );
			SetDrawScreen( pInfo->nAniGraphHandle[iCntFrame] );
			ClearDrawScreen();
			//  0, 9, 2, 11, 4, 13, 6, 15, 8, 1, 10, 3, 12, 5, 14, 7

			// nDivLine܂ŃRs[
			if ( 0 < nDivLine )
				DrawRectGraph( 0, 0, 0, 0, MAP_CHIP_SIZE, nDivLine, nSrcGraph, FALSE, FALSE );

			// nDivLineE1hbg炷
				// E[1hbg
			DrawRectGraph( 0, nDivLine, MAP_CHIP_SIZE - 1, nDivLine, 1, 1, nSrcGraph, FALSE, FALSE );
				// 2hbgڂS
			DrawRectGraph( 1, nDivLine, 0, nDivLine, MAP_CHIP_SIZE - 1, 1, nSrcGraph, FALSE, FALSE );

			// nDivLine牺Rs[
			if ( nDivLine < MAP_CHIP_SIZE - 1 )
				DrawRectGraph( 0, nDivLine + 1, 0, nDivLine + 1, MAP_CHIP_SIZE, (MAP_CHIP_SIZE - (nDivLine + 1) ), nSrcGraph, FALSE, FALSE );

			// ̏
			nSrcGraph = pInfo->nAniGraphHandle[iCntFrame];
			nDivLine = (nDivLine + 9) % MAP_CHIP_SIZE;
		}

		DeleteGraph( nHdlOrgGraph );
	}

	SetDrawScreen( DX_SCREEN_BACK );

	fclose( fp );

	return TRUE;
}
//-----------------------------------------------------------------------------
// DeleteMapChipGraph
// S}bv`bv폜
//-----------------------------------------------------------------------------
void CDataManager::DeleteMapChipGraph( void )
{
	for ( int iCnt = 0; iCnt < (int)m_aryHandleMapChip.size(); iCnt ++ )
	{
		DeleteGraph( m_aryHandleMapChip.at(iCnt) );
	}

	for ( int iCnt = 0; iCnt < (int)m_aryAniChipInfo.size(); iCnt ++ )
	{
		stAniChipInfo *pInfo = m_aryAniChipInfo.at( iCnt );
		for ( int iCntAni = 0; iCntAni < CHIP_ANIMATION_FRAME; iCntAni ++ )
		{
			DeleteGraph( pInfo->nAniGraphHandle[iCntAni] );
		}
		delete pInfo;
	}
	if ( m_aryAniChipInfo.size() )
		m_aryAniChipInfo.clear();

	m_bLoadedMapChipGraph = FALSE;

}
//-----------------------------------------------------------------------------
// LoadCharacterGraph
// SLN^GǍ
//-----------------------------------------------------------------------------
BOOL CDataManager::LoadCharacterGraph( void )
{
	if ( m_bLoadedCharacterGraph )
	{
		return TRUE;
	}

	char szFileName[MAX_PATH];
	for ( int iCnt = 0; iCnt < CHAR_GRAPH_MAX; iCnt ++ )
	{
		sprintf_s( szFileName, sizeof(szFileName), "%s\\%s%02d.png", CHAR_DATA_DIR, CHAR_GRAPH_FNAME_PREFIX, iCnt+1 );

		// Gǂݍ
		SetTransColor(0,117,117);
		m_nHandleCharacter[iCnt] = ::LoadGraph( szFileName );
		if ( m_nHandleCharacter[iCnt] == DX_FAILED )
		{
			CSysUtil::Msg("摜ǂݍݎs [%s]", szFileName );
			return FALSE;
		}
	}
	m_bLoadedCharacterGraph = TRUE;

	return TRUE;
}
//-----------------------------------------------------------------------------
// DeleteMapChipGraph
// SLN^G폜
//-----------------------------------------------------------------------------
void CDataManager::DeleteCharacterGraph( void )
{
	for ( int iCnt = 0; iCnt < CHAR_GRAPH_MAX; iCnt ++ )
	{
		DeleteGraph( m_nHandleCharacter[iCnt] );
	}

	m_bLoadedCharacterGraph = FALSE;

}

//-----------------------------------------------------------------------------
// GetMapObjectLocation
//-----------------------------------------------------------------------------
void CDataManager::GetMapObjectLocation( int *pX, int *pY, int nEventID, const CMapEvent *pMapEvent )
{
	for ( int iCnt = 0; iCnt < pMapEvent->m_nWidth * pMapEvent->m_nHeight; iCnt ++ )
	{
		if ( pMapEvent->m_wMapObject[iCnt] == nEventID )
		{
			*pX = iCnt % pMapEvent->m_nWidth;
			*pY = iCnt / pMapEvent->m_nWidth;
		}
	}
}
//-----------------------------------------------------------------------------
// LoadOneItemData
//-----------------------------------------------------------------------------
BOOL CDataManager::LoadOneItemData( int nItemID, CItem **pItem )
{
	// ̈m
	if ( CEquipItem::IsEquipItem( nItemID ) )
	{
		*pItem  = new CEquipItem();
	}
	else
	{
		*pItem  = new CItem();
	}

	// ACe
	if ( nItemID < ITEM_ID_BASE_WEAPON )
	{
		// ʏACe
		return LoadOneNormalItemDataCSV( nItemID, *pItem );	// JCSVǂ
	}
	else if ( nItemID < ITEM_ID_BASE_ACCESSORY )
	{	// /h
		return LoadOneEquipItemDataCSV( nItemID, (CEquipItem *)*pItem );	// JCSVǂ
	}
	else
	{	// ANZT

	}

	return FALSE;
}
//-----------------------------------------------------------------------------
// LoadOneNormalItemDataCSV
// Ĵݎgp
//-----------------------------------------------------------------------------
BOOL CDataManager::LoadOneNormalItemDataCSV( int nItemID, CItem *pItem )
{
	char szLine[32*1024];
	char szFileName[MAX_PATH];
	char wkBuff[1024];
	FILE *fp;

	sprintf_s( szFileName, sizeof(szFileName), "%s\\%s", ITEM_DATA_DIR, ITEM_NORMAL_CSV_FILE_NAME );
	//  Item.csv
	if ( fopen_s( &fp, szFileName, "r" ) != 0 )
	{
		CSysUtil::Msg("t@Cǂݍݎs [%s]", szFileName);
		return FALSE;
	}
	// 1,2sڂ xs
	fgets( szLine, sizeof(szLine), fp );
	fgets( szLine, sizeof(szLine), fp );

	// 3sڂf[^
	BOOL bFound = FALSE;
	CItem ItemData;
	RtlZeroMemory( &ItemData, sizeof(ItemData) );

	while ( fgets( szLine, sizeof(szLine), fp ) )
	{
		LPCSTR pPtr = szLine;

		// ID
		ItemData.nID = CCSVString::GetNextInt( pPtr );
		if ( nItemID != ItemData.nID )
		{
			continue;
		}

		// 
		bFound = TRUE;

		// O
		CCSVString::GetNextString( wkBuff, sizeof(wkBuff), pPtr );
		strcpy_s( ItemData.szName, wkBuff );

		// l
		ItemData.nValue = CCSVString::GetNextInt( pPtr );

		// 
		CCSVString::GetNextString( wkBuff, sizeof(wkBuff), pPtr );
		strcpy_s( ItemData.szDesc, wkBuff );

		break;

	}
	fclose( fp );

	if ( !bFound )
	{	return FALSE; }

	// ACeRs[
	*pItem = ItemData;

	return TRUE;
}

//-----------------------------------------------------------------------------
// LoadOneEquipItemDataCSV
// Ĵݎgp
//-----------------------------------------------------------------------------
BOOL CDataManager::LoadOneEquipItemDataCSV( int nItemID, CEquipItem *pItem )
{
	char szLine[32*1024];
	char szFileName[MAX_PATH];
	char wkBuff[1024];
	FILE *fp;

	if ( nItemID < ITEM_ID_BASE_ARMOR )
	{	// 
		sprintf_s( szFileName, sizeof(szFileName), "%s\\%s", ITEM_DATA_DIR, ITEM_WEAPON_CSV_FILE_NAME );
	}
	else
	{	// h
		sprintf_s( szFileName, sizeof(szFileName), "%s\\%s", ITEM_DATA_DIR, ITEM_ARMOR_CSV_FILE_NAME );
	}
	//  Item.csv
	if ( fopen_s( &fp, szFileName, "r" ) != 0 )
	{
		CSysUtil::Msg("t@Cǂݍݎs [%s]", szFileName);
		return FALSE;
	}
	// 1,2sڂ xs
	fgets( szLine, sizeof(szLine), fp );
	fgets( szLine, sizeof(szLine), fp );

	// 3sڂf[^
	BOOL bFound = FALSE;
	CEquipItem ItemData;
	RtlZeroMemory( &ItemData, sizeof(ItemData) );

	while ( fgets( szLine, sizeof(szLine), fp ) )
	{
		LPCSTR pPtr = szLine;

		// ID
		ItemData.nID = CCSVString::GetNextInt( pPtr );
		if ( nItemID != ItemData.nID )
		{
			continue;
		}

		// 
		bFound = TRUE;

		// O
		CCSVString::GetNextString( wkBuff, sizeof(wkBuff), pPtr );
		strcpy_s( ItemData.szName, wkBuff );
		// l
		ItemData.nValue = CCSVString::GetNextInt( pPtr );
		// 
		CCSVString::GetNextString( wkBuff, sizeof(wkBuff), pPtr );
		strcpy_s( ItemData.szDesc, wkBuff );

		// 
		ItemData.bEquiped = FALSE;
		// 
		ItemData.nType = CCSVString::GetNextInt( pPtr );
		// ʒu
		ItemData.nEquipPos = CCSVString::GetNextInt( pPtr );

		// U
		ItemData.Param.nAttack = CCSVString::GetNextInt( pPtr );
		// h
		ItemData.Param.nDefence = CCSVString::GetNextInt( pPtr );
		// @h
		ItemData.Param.nMagicDef = CCSVString::GetNextInt( pPtr );
		// 
		ItemData.Param.nParry = CCSVString::GetNextInt( pPtr );
		// @
		ItemData.Param.nMagicPar = CCSVString::GetNextInt( pPtr );
		// d
		ItemData.Param.nWeight = CCSVString::GetNextInt( pPtr );
		//  (%)
		ItemData.Param.nHitRate = CCSVString::GetNextInt( pPtr );
		// MAX HP
		ItemData.BaseParam.nMaxHP = CCSVString::GetNextInt( pPtr );
		// MAX MP
		ItemData.BaseParam.nMaxMP = CCSVString::GetNextInt( pPtr );
		// 
		ItemData.BaseParam.nStrength = CCSVString::GetNextInt( pPtr );
		// ̗
		ItemData.BaseParam.nVitality = CCSVString::GetNextInt( pPtr );
		// f
		ItemData.BaseParam.nSpeed = CCSVString::GetNextInt( pPtr );
		// 
		ItemData.BaseParam.nIntellect = CCSVString::GetNextInt( pPtr );
		// _
		ItemData.BaseParam.nPiety = CCSVString::GetNextInt( pPtr );
		// ^
		ItemData.BaseParam.nLuck = CCSVString::GetNextInt( pPtr );

		break;

	}
	fclose( fp );

	if ( !bFound )
	{	return FALSE; }

	// ACeRs[
	*pItem = ItemData;

	return TRUE;
}
//-----------------------------------------------------------------------------
// LoadEncountInfo
//-----------------------------------------------------------------------------
int CDataManager::LoadEncountInfo( int nEncountID, std::vector< stEncountInfo *> &aryEncountInfo )
{
	char szLine[32*1024];
	char szFileName[MAX_PATH];
	FILE *fp;

	sprintf_s( szFileName, sizeof(szFileName), "%s\\%s", ENEMY_TABLE_DIR, ENCOUNT_TABLE_FILE_NAME );

	//  Item.csv
	if ( fopen_s( &fp, szFileName, "r" ) != 0 )
	{
		CSysUtil::Msg("t@Cǂݍݎs [%s]", szFileName);
		return FALSE;
	}
	// 1,2sڂ xs
	fgets( szLine, sizeof(szLine), fp );
	fgets( szLine, sizeof(szLine), fp );

	// 3sڂf[^
	BOOL bFound = FALSE;
	while ( fgets( szLine, sizeof(szLine), fp ) )
	{
		LPCSTR pPtr = szLine;

		// ID
		int nID = CCSVString::GetNextInt( pPtr );
		if ( nID != nEncountID )
		{
			continue;
		}
		// 
		bFound = TRUE;

		for ( int iCnt = 0; iCnt < 10; iCnt ++ )
		{
			stEncountInfo *pInfo = new stEncountInfo();
			RtlZeroMemory( pInfo, sizeof(stEncountInfo) );

			aryEncountInfo.push_back( pInfo );

			// X^[p[eBID
			pInfo->nPartyID = CCSVString::GetNextInt( pPtr );

			// 
			pInfo->nRate = CCSVString::GetNextInt( pPtr );
		}

		break;

	}
	fclose( fp );

	if ( !bFound )
	{	return FALSE; }


	return TRUE;
}

//-----------------------------------------------------------------------------
// LoadFrameWndGraph
//-----------------------------------------------------------------------------
BOOL CDataManager::LoadFrameWndGraph( void )
{
	// ɓǂݍݍς݂
	if ( m_bLoadedFrameWndGraph )
	{
		return TRUE;
	}

	// t[Gǂݍ
	int iRet = LoadDivGraph( WINDOW_FRAME_CHIPS_FILE_NAME , 8 , 9 , 1 , FRAME_CHIP_ONE_SIDE_SIZE, FRAME_CHIP_ONE_SIDE_SIZE , m_nHandleFrameWnd ) ;
	if ( iRet != DX_SUCCESS )
	{
		CSysUtil::Msg("摜ǂݍݎs [%s]", WINDOW_FRAME_CHIPS_FILE_NAME);
		return FALSE;
	}

	// wi쐬
	const int BACK_GROUND = 8;
	m_nHandleFrameWnd[ BACK_GROUND ] = MakeGraph( CANVAS_WIDTH, CANVAS_HEIGHT ) ;
	// `ύX
	SetDrawScreen( m_nHandleFrameWnd[ BACK_GROUND ] );

	const int nThickness = 8;	// 1Linȇ
	const int nInitR = 128;
	const int nInitG = 128;
	const int nInitB = 255;
	for ( int iCnt = 0; iCnt < CANVAS_HEIGHT; iCnt += nThickness )
	{	// FvZ

		int nR,nG,nB;
		// œ삪ς
		if ( iCnt < (CANVAS_HEIGHT/2) )
		{	// ԗ 128 -> 0
			nR = nInitR * (CANVAS_HEIGHT/2 - iCnt) / (CANVAS_HEIGHT/2);
			nG = nInitG * (CANVAS_HEIGHT/2 - iCnt) / (CANVAS_HEIGHT/2);
			nB = nInitB;
		}
		else
		{	//   255 -> 0
			nR = nG = 0;
			nB = nInitB - ((iCnt + nThickness) - CANVAS_HEIGHT/2);
		}
		// C`
		DWORD dwColor = GetColor( nR, nG, nB );
		DrawLine( 0, iCnt, CANVAS_WIDTH, iCnt, dwColor, nThickness );
	}
	// `߂
	SetDrawScreen( DX_SCREEN_BACK );

	m_bLoadedFrameWndGraph = TRUE;

	return TRUE;
}
//-----------------------------------------------------------------------------
// DeleteFrameWndGraph
// St[EBhEG폜
//-----------------------------------------------------------------------------
void CDataManager::DeleteFrameWndGraph( void )
{
	for ( int iCnt = 0; iCnt < FRAME_CHIP_COUNT; iCnt ++ )
	{
		if ( m_nHandleFrameWnd[iCnt] )
		{
			DeleteGraph( m_nHandleFrameWnd[iCnt] );
		}
	}
	m_bLoadedFrameWndGraph = FALSE;
}



//-----------------------------------------------------------------------------
// LoadLvInfoDataCSV
// Ĵݎgp
//-----------------------------------------------------------------------------
BOOL CDataManager::LoadLvInfoDataCSV( int nPlayerCharID, int nLv, BASE_PARAM *pBaseParam )
{
	char szLine[32*1024];
	char szFileName[MAX_PATH];
	FILE *fp;

	sprintf_s( szFileName, sizeof(szFileName), "%s\\%s%03d.csv", LV_INFO_DATA_DIR, LV_INFO_DATA_FNAME_PREFIX, nPlayerCharID );

	//  Item.csv
	if ( fopen_s( &fp, szFileName, "r" ) != 0 )
	{
		CSysUtil::Msg("t@Cǂݍݎs [%s]", szFileName);
		return FALSE;
	}
	// 1,2sڂ xs
	fgets( szLine, sizeof(szLine), fp );
	fgets( szLine, sizeof(szLine), fp );

	// 3sڂf[^
	BOOL bFound = FALSE;
	BASE_PARAM BaseParam;
	RtlZeroMemory( &BaseParam, sizeof(BaseParam) );

	while ( fgets( szLine, sizeof(szLine), fp ) )
	{
		LPCSTR pPtr = szLine;

		// Lv
		int nWkLv = CCSVString::GetNextInt( pPtr );
		if ( nWkLv != nLv )
		{
			continue;
		}
		// 
		bFound = TRUE;

		// Kvol(ݐ)
		int nExp = CCSVString::GetNextInt( pPtr );

		// MaxHP
		BaseParam.nMaxHP = CCSVString::GetNextInt( pPtr );
		// MAX MP
		BaseParam.nMaxMP = CCSVString::GetNextInt( pPtr );
		// 
		BaseParam.nStrength = CCSVString::GetNextInt( pPtr );
		// ̗
		BaseParam.nVitality = CCSVString::GetNextInt( pPtr );
		// f
		BaseParam.nSpeed = CCSVString::GetNextInt( pPtr );
		// 
		BaseParam.nIntellect = CCSVString::GetNextInt( pPtr );
		// _
		BaseParam.nPiety = CCSVString::GetNextInt( pPtr );
		// ^
		BaseParam.nLuck = CCSVString::GetNextInt( pPtr );

		break;

	}
	fclose( fp );

	if ( !bFound )
	{	return FALSE; }

	// ACeRs[
	*pBaseParam = BaseParam;

	return TRUE;
}

//-----------------------------------------------------------------------------
// GetToNextLvCSV
// Ĵݎgp
//-----------------------------------------------------------------------------
int CDataManager::GetToNextLvCSV( int nPlayerCharID, int nLv, int nExp )
{
	char szLine[32*1024];
	char szFileName[MAX_PATH];
	FILE *fp;

	int nRetExp = 0;

	sprintf_s( szFileName, sizeof(szFileName), "%s\\%s%03d.csv", LV_INFO_DATA_DIR, LV_INFO_DATA_FNAME_PREFIX, nPlayerCharID );

	//  Item.csv
	if ( fopen_s( &fp, szFileName, "r" ) != 0 )
	{
		CSysUtil::Msg("t@Cǂݍݎs [%s]", szFileName);
		return FALSE;
	}
	// 1,2sڂ xs
	fgets( szLine, sizeof(szLine), fp );
	fgets( szLine, sizeof(szLine), fp );

	// 3sڂf[^
	BOOL bFound = FALSE;
	BASE_PARAM BaseParam;
	RtlZeroMemory( &BaseParam, sizeof(BaseParam) );

	while ( fgets( szLine, sizeof(szLine), fp ) )
	{
		LPCSTR pPtr = szLine;

		// Lv
		int nWkLv = CCSVString::GetNextInt( pPtr );
		if ( nWkLv != nLv + 1 )
		{
			continue;
		}
		// 
		bFound = TRUE;

		// Kvol(ݐ)
		int nWkExp = CCSVString::GetNextInt( pPtr );
		nRetExp = nWkExp - nExp;
		if ( nRetExp < 0 )
			nRetExp = 0;
		break;

	}
	fclose( fp );

	if ( !bFound )
	{	return 0; }

	return nRetExp;
}
//-----------------------------------------------------------------------------
// GetCharName
//-----------------------------------------------------------------------------
const char *CDataManager::GetCharName( int nPlayerCharID ) const
{
	switch ( nPlayerCharID )
	{
	case 0:
		return "";
	case 1:
		return "fBm";
	case 2:
		return "}A";
	case 3:
		return "~A";
	case 4:
		return "WbNX";
	}
	return "";
}


//  Wu֘A
// ToDo : ̃NXɉu
//-----------------------------------------------------------------------------
// GetJobName
//-----------------------------------------------------------------------------
const char *CDataManager::GetJobName( int nID )
{
	switch ( nID )
	{
	case JOB_ID_SUPPIN:
		return "҂";

	case JOB_ID_KNIGHT:
		return "";

	case JOB_ID_BLACK_WIZARD:
		return "܂ǂ";

	case JOB_ID_WHITE_WIZARD:
		return "܂ǂ";

	default:
		break;
	}
	return "ӂ߂";
}
//  R}h֘A
//-----------------------------------------------------------------------------
// GetCommandText
//-----------------------------------------------------------------------------
const char *CDataManager::GetCommandText( int nID )
{
	switch ( nID )
	{
	case COMMAND_ID_ATTACK:
		return "";
	case COMMAND_ID_ITEM:
		return "ACe";
	case COMMAND_ID_GUARD:
		return "ڂ";
	case COMMAND_ID_PASS:
		return "pX";
	case COMMAND_ID_CHANGE:
		return "`FW";

	default:
		break;
	}

	return "ӂ߂";
}
//  @֘A
//-----------------------------------------------------------------------------
// GetMagicName
//-----------------------------------------------------------------------------
const char *CDataManager::GetMagicName( int nID )
{
	switch ( nID )
	{
	// 
	case MAGIC_ID_CAREL:
		return "PA";
	case MAGIC_ID_LIBRA:
		return "Cu";
	case MAGIC_ID_POISONA:
		return "|C]i";

	// 
	case MAGIC_ID_FIRE:
		return "t@CA";
	case MAGIC_ID_BLIZZARD:
		return "uUh";
	case MAGIC_ID_THUNDER:
		return "T_[";

	default:
		break;
	}
	return "ӂ߂";
}

//-----------------------------------------------------------------------------
// LoadEnemyParty
//-----------------------------------------------------------------------------
BOOL CDataManager::LoadEnemyParty( int nPartyID, std::vector<CEnemy *> &lstEnemy )
{
	lstEnemy.clear();

	char szFileName[MAX_PATH];
	char szLine[32*1024];
	char wkBuff[1024];
	FILE *fp;

	int nArrangePtnID;							// zup^[ID
	int nEnemyCount;
	int nEnemyID[BATTLE_ENEMY_COUNT_MAX];		// GID
	POSITION nEnemyPos[BATTLE_ENEMY_COUNT_MAX];	// Gzuʒu
	RtlZeroMemory( nEnemyID, sizeof(nEnemyID) );


	//  EnemyPartyTable.csv
	sprintf_s( szFileName, sizeof(szFileName), "%s\\%s", ENEMY_TABLE_DIR, ENEMY_PARTY_TABLE_FILE_NAME );
	if ( fopen_s( &fp, szFileName, "r" ) != 0 )
	{
		CSysUtil::Msg( "t@Cǂݍݎs [%s]", szFileName );
		return FALSE;
	}
	// 1,2sڂ xs
	fgets( szLine, sizeof(szLine), fp );
	fgets( szLine, sizeof(szLine), fp );

	// 3sڂf[^
	while ( fgets( szLine, sizeof(szLine), fp ) )
	{
		LPCSTR pPtr = szLine;
		if ( CCSVString::GetNextInt( pPtr ) != nPartyID )
		{	// ID
			continue;
		}

		// O
		CCSVString::GetNextString( wkBuff, sizeof(wkBuff), pPtr );

		// X^[
		CCSVString::GetNextInt( pPtr );

		// zup^[ID
		nArrangePtnID = CCSVString::GetNextInt( pPtr );

		// X^[ID
		for ( int iCnt = 0; iCnt < BATTLE_ENEMY_COUNT_MAX; iCnt ++ )
		{
			nEnemyID[iCnt] = CCSVString::GetNextInt( pPtr );
		}
		// ꏈtO
		CCSVString::GetNextInt( pPtr );
		// ꏈp^
		CCSVString::GetNextInt( pPtr );
		// ꏈtO2
		CCSVString::GetNextInt( pPtr );
		// ꏈp^2
		CCSVString::GetNextInt( pPtr );

		break;	// ̂ŌȂ
	}

	fclose( fp );



	//  ArrangeTable.csv
	sprintf_s( szFileName, sizeof(szFileName), "%s\\%s", ENEMY_TABLE_DIR, ARRANGE_TABLE_FILE_NAME );
	if ( fopen_s( &fp, szFileName, "r" ) != 0 )
	{
		CSysUtil::Msg("t@Cǂݍݎs [%s]", szFileName );
		return FALSE;
	}
	// 1,2sڂ xs
	fgets( szLine, sizeof(szLine), fp );
	fgets( szLine, sizeof(szLine), fp );

	// 3sڂf[^
	while ( fgets( szLine, sizeof(szLine), fp ) )
	{
		LPCSTR pPtr = szLine;

		if ( nArrangePtnID  != CCSVString::GetNextInt( pPtr ) )
		{	// ID
			continue;
		}
		// X^[
		nEnemyCount = CCSVString::GetNextInt( pPtr );

		// X^[ʒu
		for ( int iCnt = 0; iCnt < BATTLE_ENEMY_COUNT_MAX; iCnt ++ )
		{
			nEnemyPos[iCnt].nPosX = CCSVString::GetNextInt( pPtr );
			nEnemyPos[iCnt].nPosY = CCSVString::GetNextInt( pPtr );
		}
		break;	// ̂ŌȂ
	}
	fclose( fp );


	
	//  EnemyTable.csv
	sprintf_s( szFileName, sizeof(szFileName), "%s\\%s", ENEMY_TABLE_DIR, ENEMY_TABLE_FILE_NAME );
	if ( fopen_s( &fp, szFileName, "r" ) != 0 )
	{
		CSysUtil::Msg("t@Cǂݍݎs [%s]", szFileName);
		return FALSE;
	}
	// 1,2sڂ xs
	fgets( szLine, sizeof(szLine), fp );
	fgets( szLine, sizeof(szLine), fp );

	// 3sڂf[^
	int nCount = 0;

	while ( fgets( szLine, sizeof(szLine), fp ) )
	{
		for ( int iCnt = 0; iCnt < BATTLE_ENEMY_COUNT_MAX; iCnt ++ )
		{	// Gp[eB[f[^ɂ邩
			LPCSTR pPtr = szLine;
			// ID
			int nID = CCSVString::GetNextInt( pPtr );
			if ( nID == nEnemyID[iCnt] )
			{
				
				CEnemy *pEnemy = new CEnemy();
				lstEnemy.push_back( pEnemy );

				// ʒu
				pEnemy->SetPos( nEnemyPos[iCnt].nPosX, nEnemyPos[iCnt].nPosY );

				// ID
				pEnemy->m_Info.nID = nEnemyID[iCnt];

				// O
				CCSVString::GetNextString( pEnemy->m_Info.szName, sizeof(pEnemy->m_Info.szName), pPtr );

				// ݂̃x
				pEnemy->m_Info.nLV = CCSVString::GetNextInt( pPtr ); 

				// MaxHP
				pEnemy->m_Param.Base.nMaxHP = CCSVString::GetNextInt( pPtr ); 
				pEnemy->m_Info.nHP = pEnemy->m_Param.Base.nMaxHP;

				// MaxMP
				pEnemy->m_Param.Base.nMaxMP = CCSVString::GetNextInt( pPtr ); 
				pEnemy->m_Info.nMP = pEnemy->m_Param.Base.nMaxMP;

				// ATBl
				pEnemy->m_Info.nAtbValue = CCSVString::GetNextInt( pPtr ); 

				// U
				pEnemy->m_Param.nAttack = CCSVString::GetNextInt( pPtr ); 

				// h
				pEnemy->m_Param.nDefence = CCSVString::GetNextInt( pPtr ); 

				// @h
				pEnemy->m_Param.nMagicDef = CCSVString::GetNextInt( pPtr ); 

				// 
				pEnemy->m_Param.nParry = CCSVString::GetNextInt( pPtr ); 

				// @
				pEnemy->m_Param.nMagicPar = CCSVString::GetNextInt( pPtr ); 

				// 
				pEnemy->m_Param.Base.nStrength = CCSVString::GetNextInt( pPtr ); 
  
				// ̗
				pEnemy->m_Param.Base.nVitality = CCSVString::GetNextInt( pPtr ); 

				// f
				pEnemy->m_Param.Base.nSpeed = CCSVString::GetNextInt( pPtr ); 

				// 
				pEnemy->m_Param.Base.nIntellect = CCSVString::GetNextInt( pPtr ); 

				// _
				pEnemy->m_Param.Base.nPiety = CCSVString::GetNextInt( pPtr ); 

				// ^
				pEnemy->m_Param.Base.nLuck = CCSVString::GetNextInt( pPtr ); 

				// LM
				pEnemy->m_Info.nGill = CCSVString::GetNextInt( pPtr ); 

				// o
				pEnemy->m_Info.nExp = CCSVString::GetNextInt( pPtr ); 

				// R}h
				for ( int iCnt = 0; iCnt < ENEMY_MAX_CMD_CNT; iCnt ++ )
				{
					pEnemy->m_Info.nCommandID[iCnt] = CCSVString::GetNextInt( pPtr ); 
				}

				// ACe
				for ( int iCnt = 0; iCnt < ENEMY_MAX_ITEM_CNT; iCnt ++ )
				{
					pEnemy->m_Info.nItemID[iCnt] = CCSVString::GetNextInt( pPtr ); 
				}

				nCount ++;
			}
		}

		if ( nEnemyCount <= nCount )
		{	// ̂ŌȂ
			break;
		}
	}
	fclose( fp );

	return TRUE;
}
