//=============================================================================
// Effect.cpp
//=============================================================================
#include "Stdinc.h"
#include "Effect.h"

//-----------------------------------------------------------------------------
// RXgN^
//-----------------------------------------------------------------------------
CEffect::CEffect(void)
	:m_nFrameCnt( 0 ), m_nShakeOffset( 0 ), m_nEffectType( EFFECT_TYPE_NONE )
{
	m_nHandleRenderTgt = MakeGraph( CANVAS_WIDTH, CANVAS_HEIGHT ) ;
}

//-----------------------------------------------------------------------------
// fXgN^
//-----------------------------------------------------------------------------
CEffect::~CEffect(void)
{
	DeleteGraph( m_nHandleRenderTgt );
}
//-----------------------------------------------------------------------------
// StartFadeout
//-----------------------------------------------------------------------------
void CEffect::StartFadeout( DWORD dwFadeColor, UINT nFameCnt )
{
	m_nStartFrameCnt = m_nFrameCnt = nFameCnt;
	m_dwFadeColor = dwFadeColor;

	m_nEffectType = EFFECT_TYPE_FADE_OUT;
}
//-----------------------------------------------------------------------------
// StartFadein
//-----------------------------------------------------------------------------
void CEffect::StartFadein( DWORD dwFadeColor, UINT nFameCnt )
{
	m_nStartFrameCnt = m_nFrameCnt = nFameCnt;
	m_dwFadeColor = dwFadeColor;

	m_nEffectType = EFFECT_TYPE_FADE_IN;
}
//-----------------------------------------------------------------------------
// StartShake
//-----------------------------------------------------------------------------
void CEffect::StartShake( int Type, UINT nFrame, double dblSpeed, int nScale )
{
	const int SHAKE_V = 0;
	const int SHAKE_H = 1;

	if ( Type == SHAKE_V )
		m_nEffectType = EFFECT_TYPE_V_SHAKE;
	else 
		m_nEffectType = EFFECT_TYPE_H_SHAKE;

	m_nStartFrameCnt = m_nFrameCnt = nFrame;

	m_dblShakeSpeed = dblSpeed;
	if ( m_dblShakeSpeed == 0.0 )
		m_dblShakeSpeed = 0.1f;

	m_nShakeScale = nScale;

}
//-----------------------------------------------------------------------------
// StartEncount
//-----------------------------------------------------------------------------
void CEffect::StartEncount( void )
{
	m_nEffectType = EFFECT_TYPE_ENCOUNT;
	m_nStartFrameCnt = m_nFrameCnt = 34;
}
//-----------------------------------------------------------------------------
// FrameMove
//-----------------------------------------------------------------------------
void CEffect::FrameMove( void )
{
	if ( m_nFrameCnt <= 0 )
		return;

	m_nFrameCnt --;
}
#include <math.h>
//-----------------------------------------------------------------------------
// Render
//-----------------------------------------------------------------------------
void CEffect::Render( void )
{
	if ( m_nFrameCnt <= 0 )
	{
		m_nShakeOffset = 0;
		return;
	}

	int nRate = (int)((double)m_nFrameCnt * 255.0 / (double)m_nStartFrameCnt);

	if ( m_nEffectType == EFFECT_TYPE_FADE_IN ||
		 m_nEffectType == EFFECT_TYPE_FADE_OUT )
	{	// tF[hC / tF[hAEg
		if ( m_nEffectType == EFFECT_TYPE_FADE_OUT )
		{
			nRate = 255 - nRate;
		}
		// uh[hݒ
		SetDrawBlendMode( DX_BLENDMODE_ALPHA, nRate );

		// ʑŜɋ``
		DrawBox( 0, 0, CANVAS_WIDTH+1, CANVAS_HEIGHT+1, m_dwFadeColor, TRUE );

		// uh[h߂
		SetDrawBlendMode( DX_BLENDMODE_NOBLEND , 255 );
	}

	else if ( m_nEffectType == EFFECT_TYPE_V_SHAKE ||
			  m_nEffectType == EFFECT_TYPE_H_SHAKE )
	{	// ʗh炵
		//m_nShakeOffsetX = (int)( sin( m_nFrameCnt / 6.67f ) * 8 );
		m_nShakeOffset = (int)( sin( m_nFrameCnt / m_dblShakeSpeed ) * m_nShakeScale );
	}
}
//-----------------------------------------------------------------------------
// PreRender
//-----------------------------------------------------------------------------
void CEffect::PreRender( void )
{
	if ( m_nFrameCnt <= 0 )
	{
		return;
	}

	if ( m_nEffectType == EFFECT_TYPE_ENCOUNT )
	{	// GJEg
		SetDrawScreen( m_nHandleRenderTgt );
		ClearDrawScreen();
	}
}
//-----------------------------------------------------------------------------
// PostRender
//-----------------------------------------------------------------------------
void CEffect::PostRender( void )
{
	if ( m_nFrameCnt <= 0 || 
		 m_nEffectType != EFFECT_TYPE_ENCOUNT )
	{
		return;
	}

	int nOffset = 0;
	if ( m_nEffectType == EFFECT_TYPE_ENCOUNT )
	{	// GJEg

		if ( 14 < m_nFrameCnt )
		{	// 20t[g
			nOffset = m_nStartFrameCnt - m_nFrameCnt + 1;
		}
		else if ( 4 < m_nFrameCnt )
		{	// 10t[k
			nOffset = 20 + 20 - (m_nStartFrameCnt - m_nFrameCnt);
		}
		else 
		{	// 4t[ubNAEg
			SetDrawScreen( DX_SCREEN_BACK );
			DrawBox( 0, 0, CANVAS_WIDTH+1, CANVAS_HEIGHT+1, GetColor(0,0,0), TRUE );
			return;
		}

		nOffset += 2;
	}
	int nWidth = CANVAS_WIDTH/nOffset;
	int nHeight = CANVAS_HEIGHT/nOffset;

	// keNX`쐬
	int hdlMipMap = MakeGraph( nWidth, nHeight ) ;
	SetDrawScreen( hdlMipMap );

	// eNX`ɕ`
	SetDrawMode( DX_DRAWMODE_NEAREST ) ;
	DrawExtendGraph( 0, 0,nWidth,nHeight, m_nHandleRenderTgt , FALSE ) ;

	// _O^[Qbg؂ւ
	SetDrawScreen( DX_SCREEN_BACK );

	//LOG_OUTPUT("Frame [%d] nOffset[%d]\n", m_nStartFrameCnt - m_nFrameCnt, nOffset );

	// eNX``
	DrawExtendGraph( 0, 0 , CANVAS_WIDTH+1 , CANVAS_HEIGHT+1 , hdlMipMap , FALSE ) ;

	DeleteGraph( hdlMipMap );
}
