//=============================================================================
// EncountManager.cpp
//=============================================================================
#include "Stdinc.h"
#include "EncountManager.h"
#include "MapManager.h"
#include "DataManager.h"

//-----------------------------------------------------------------------------
// RXgN^
//-----------------------------------------------------------------------------
CEncountManager::CEncountManager(void)
	:m_nEncountCounter( 0 ), m_nNextEncountCount( 0 )
{
}

//-----------------------------------------------------------------------------
// fXgN^
//-----------------------------------------------------------------------------
CEncountManager::~CEncountManager(void)
{
}
//-----------------------------------------------------------------------------
// Initialize
//-----------------------------------------------------------------------------
BOOL CEncountManager::Initialize( CMapManager *pMap )
{
	m_pMapMan = pMap;

	return TRUE;
}
//-----------------------------------------------------------------------------
// Finalize
//-----------------------------------------------------------------------------
void CEncountManager::Finalize( void )
{
}
//-----------------------------------------------------------------------------
// CheckEncount
//-----------------------------------------------------------------------------
int CEncountManager::CheckEncount( void )
{
	// Go}bv
	if ( !m_pMapMan->IsEncount() )
		return ENCOUNT_PARTY_NONE;

	// Ă邩
	int nCenterX, nCenterY;
	m_pMapMan->GetCenterPos( &nCenterX, &nCenterY );

	if ( m_nLastCenterPosX == nCenterX && m_nLastCenterPosY == nCenterY )
		return ENCOUNT_PARTY_NONE;

	m_nLastCenterPosX = nCenterX;
	m_nLastCenterPosY = nCenterY;

	// K`FbN
	if ( m_nNextEncountCount == 0 )
		m_nNextEncountCount = GetNextEncountCount();

	m_nEncountCounter ++;

	if ( m_nNextEncountCount <= m_nEncountCounter )
	{	// GJEg
		m_nNextEncountCount = GetNextEncountCount();
		m_nEncountCounter = 0;

		int nRet = GetEncountParty();
		LOG_OUTPUT( "GJEg [%d] ̃GJEg܂ł̕ [%d]\n", nRet, m_nNextEncountCount );

		// GJEgGp[eB擾
		return nRet;
	}

	return ENCOUNT_PARTY_NONE;
}
//-----------------------------------------------------------------------------
// GetNextEncountCount
// 10`39̊
//-----------------------------------------------------------------------------
int CEncountManager::GetNextEncountCount( void )
{
	int nRet = GetRand( 99990 );
	nRet %= 30;
	nRet += 10;

	return nRet;
}
//-----------------------------------------------------------------------------
// GetEncountParty
//-----------------------------------------------------------------------------
int CEncountManager::GetEncountParty( void )
{
	int nCenterX, nCenterY;
	m_pMapMan->GetCenterPos( &nCenterX, &nCenterY );
	int nIndex = nCenterY*m_pMapMan->GetWidth()+nCenterX;

	WORD wEncountID = (* m_pMapMan->GetEncountFlag())[nIndex];

	std::vector< stEncountInfo *> aryEncountInfo;
	if ( !CDataManager::GetInstance()->LoadEncountInfo( wEncountID, aryEncountInfo ) )
		return ENCOUNT_PARTY_NONE;

	int nValue = GetRand( 101 * 9999 ) % 101;
	int nSumRate = 0;
	int nPartyID = ENCOUNT_PARTY_NONE;
	for ( int iCnt = 0; iCnt < (int)aryEncountInfo.size(); iCnt ++ )
	{
		nSumRate += aryEncountInfo.at( iCnt )->nRate;
		if ( nValue <= nSumRate )
		{
			nPartyID = aryEncountInfo.at( iCnt )->nPartyID;
			break;
		}
	}

	// 폜
	for ( int iCnt = 0; iCnt < (int)aryEncountInfo.size(); iCnt ++ )
	{
		stEncountInfo *pInfo = aryEncountInfo.at( iCnt );
		delete pInfo;
	}


	return nPartyID;
}