//=============================================================================
// Enemy.h
//=============================================================================
#pragma once
#include "drawable.h"
#include "NumberAnimation.h"

class CBattle;

//-----------------------------------------------------------------------------
// CEnemy
//-----------------------------------------------------------------------------
class CEnemy : public CDrawable
{
public:
	enum {
		ANI_PTN_NONE = 0,			// Aj[V
		ANI_PTN_WALK_AT_START,		// Jns
		ANI_PTN_ATTACK,				// U
	};

protected:
	int		m_nHandle;					// Gnh
	int		m_nGraphWidth;				// G̃TCY
	int		m_nGraphHeight;

	int		m_nAnimationPtrn;			// Aj[Vp^[
	UINT	m_nAniFrameCount;			// Aj[VJE^ (fNg)
	BOOL	m_bDrawBlink;

	void StopAnimation( void );

public:	// ANZXȈՉ
	ENEMY_INFO			m_Info;			// LN^
	PARAM				m_Param;		// p^
	STATUS				m_Status;		// Xe[^X

	UINT				m_nFrameCount;	// t[JE^
	BOOL				m_bWaitAction;	// ANVXgs҂

	// lAj[V
	CNumberAnimation	m_NumAnime;		// lAj[V
	void GetNumAnimeDispPos( int *pX, int *pY, int iDispWidth );

	// x[Xp^p^vZ
	void CalcParam( void );

public:
	CEnemy(void);
	virtual ~CEnemy(void);

	BOOL Create( void );		// 
	void FrameMove( void ); 	// XV
	void Render( void );		// `
	void Delete( void );		// j

	// ANVXgs҂
	void SetWaitAction( BOOL bFlag )
	{	m_bWaitAction = bFlag;	};

	BOOL IsWaitingAction( void ) const
	{	return m_bWaitAction;	};

	BOOL IsAtbMax( void ) const
	{	return ( ATB_VALUE_MAX <= m_Info.nAtbValue );	};

	// Ă邩
	BOOL IsAliving( void ) const
	{	return ( 0 < m_Info.nHP );	};

	int ChoiceCommand( void );

	// J[\ʒu
	void GetCursorDispPos( int *pX, int *pY );

	// sANV̌
	BOOL DecideAction( TIMEKEEP_INFO *pNewAction, CPlayerParty *pPlayerParty );

	// UΏۂ
	int SelectAttackTarget( CPlayerParty *pPlayerParty );

	// HP
	void ChangeHitPoint( int iDiff );

	// Aj[VJn
	void StartAction( int nAniPtnNo );

	BOOL IsActing( void )
	{	return m_nAniFrameCount;	};

	// ATB|Cg폜
	void ClearATBValue( void )
	{	m_Info.nAtbValue = 0;	};

};

