//=============================================================================
// EnemyPartyWindow.cpp
//=============================================================================
#include "Stdinc.h"
#include "EnemyPartyWindow.h"
#include "Enemy.h"
#include <map>
//-----------------------------------------------------------------------------
// RXgN^
//-----------------------------------------------------------------------------
CEnemyPartyWindow::CEnemyPartyWindow(void)
: m_nLastAliveCount( 0 )
{
}

//-----------------------------------------------------------------------------
// fXgN^
//-----------------------------------------------------------------------------
CEnemyPartyWindow::~CEnemyPartyWindow(void)
{
}

//-----------------------------------------------------------------------------
// Create
//-----------------------------------------------------------------------------
BOOL CEnemyPartyWindow::Create( int iPosX, int iPosY, int iWidth, int iHeight, std::vector<CEnemy *> &lstEnemy )
{

	BOOL bRet = CMsgWindow::Create( iPosX, iPosY, iWidth, iHeight );

	// GXgRs[
	m_lstEnemy.assign( lstEnemy.begin(),lstEnemy.end() );
	std::copy(lstEnemy.begin(),lstEnemy.end(),m_lstEnemy.begin());

	return bRet;
}
//-----------------------------------------------------------------------------
// FrameMove
//-----------------------------------------------------------------------------
void CEnemyPartyWindow::FrameMove( void )
{
	UpdateNameList();
}
//-----------------------------------------------------------------------------
// Render
//-----------------------------------------------------------------------------
void CEnemyPartyWindow::Render( void )
{
	CMsgWindow::Render();
}
//-----------------------------------------------------------------------------
// UpdateNameList
//-----------------------------------------------------------------------------
void CEnemyPartyWindow::UpdateNameList( void )
{
	// ĂG̃JEg
	int nAliveCount = 0;
	for ( int iCnt = 0; iCnt < (int)m_lstEnemy.size(); iCnt ++ )
	{
		CEnemy *pEnemy = m_lstEnemy.at( iCnt );
		if ( !pEnemy || pEnemy->m_Info.nHP <= 0 )
			continue;	// HP 0̓G͏O

		nAliveCount ++ ;
	}

	// ω
	if ( nAliveCount == m_nLastAliveCount )
		return;

	m_nLastAliveCount = nAliveCount;

	using namespace std;

	typedef struct {
		int			nCount;	// ID̓G
		const char*	lpzName;	// O
	}stEnemyListInfo;

	map<int, stEnemyListInfo*> mapItem;
	map<int, stEnemyListInfo*>::iterator itlMap;

	// 
	for ( int iCnt = 0; iCnt < DISPLAY_MESSAGE_LINE_MAX; iCnt ++ )
	{
		strcpy_s( m_szDisplayMsg[iCnt], _countof(m_szDisplayMsg[iCnt]), "" ); 
	}
	// GO擾
	for ( int iCnt = 0; iCnt < (int)m_lstEnemy.size(); iCnt ++ )
	{
		CEnemy *pEnemy = m_lstEnemy.at( iCnt );
		// ŏ炢Ȃ ł牽Ȃ
		if ( !pEnemy || pEnemy->m_Info.nHP <= 0 )
			continue;

		// ID͂łɑ݂邩

		itlMap = mapItem.find( pEnemy->m_Info.nID );
		if ( itlMap == mapItem.end() )
		{	// ݂Ȃ  ǉ
			stEnemyListInfo *pInfo = new stEnemyListInfo;
			pInfo->nCount = 1;
			pInfo->lpzName = pEnemy->m_Info.szName;

			mapItem.insert(pair<int, stEnemyListInfo*>( pEnemy->m_Info.nID , pInfo));
		}
		else 
		{	// ݂  XV
			(itlMap->second)->nCount ++;
		}
	}
	// XV폜
	int iLineCount = 0;
	for( itlMap = mapItem.begin(); itlMap != mapItem.end(); itlMap++ )
	{
		stEnemyListInfo *pInfo = (itlMap->second);

		if ( pInfo->nCount == 1 )
		{	// 1C
			strcpy_s( m_szDisplayMsg[iLineCount], pInfo->lpzName );
		}
		else
		{	// C
			sprintf_s( m_szDisplayMsg[iLineCount], "%s %d", pInfo->lpzName, pInfo->nCount );
		}

		++ iLineCount;
		delete pInfo;
	}
}