//=============================================================================
// EquipCharWindow.cpp
//=============================================================================
#include "Stdinc.h"
#include "EquipCharWindow.h"
#include "PlayerParty.h"
#include "EquipWindow.h"
#include "DataManager.h"
#include "Manipulator.h"
//-----------------------------------------------------------------------------
// RXgN^
//-----------------------------------------------------------------------------
CEquipCharWindow::CEquipCharWindow(void)
{
	m_nType = MENU_TYPE_VERTICAL;	// c^j[
}

//-----------------------------------------------------------------------------
// fXgN^
//-----------------------------------------------------------------------------
CEquipCharWindow::~CEquipCharWindow(void)
{
}

//-----------------------------------------------------------------------------
// Create
//-----------------------------------------------------------------------------
BOOL CEquipCharWindow::Create( int iPosX, int iPosY, int iWidth, int iHeight, CPlayerParty *pParty, CEquipWindow *pParent )
{
	BOOL bRet = CFrameWindow::Create( iPosX, iPosY, iWidth, iHeight );

	m_pPlayerParty = pParty;
	m_pParent = pParent;

	
	// _~[ACeǉ
	const int BASE_POS_X  = m_nPosX + 100;
	const int BASE_POS_Y  = m_nPosY + 20;
	const int INCREMENT_Y = 12;

	for ( int iCnt = 0; iCnt < CHR_POS_MAX; iCnt ++ )
	{
		stMenuItem Item;
		Item.nID = iCnt;
		Item.bEnabled = TRUE;

		// ʒu
		Item.nPosX = BASE_POS_X;
		Item.nPosY = INCREMENT_Y * iCnt + BASE_POS_Y;
		if ( 2 <= iCnt )
			Item.nPosY += 3;

		Item.lpzText = "ACe";
		Item.nIcon = 0;
		Item.nCount = 0;

		AddMenuItem( &Item );
	}

	return bRet;
}
//-----------------------------------------------------------------------------
// FrameMove
//-----------------------------------------------------------------------------
void CEquipCharWindow::FrameMove( const CManipulator *pMani )
{
	if ( !m_bFocused )
		return;

	int nLastCurPos = GetCurPos();
	CMenuWindow::FrameMove( pMani );

	// IʒuύX
	if ( nLastCurPos != GetCurPos() )
	{
		m_pParent->NotifyCurPosChange( this, GetCurPos() );
	}
	// LZL[
	if ( pMani->CheckKey( KEY_INPUT_Z ) )
	{
		m_pParent->NotifyCancelKey( this );
	}
	// L[
	else if ( pMani->CheckKey( KEY_INPUT_X ) )
	{
		m_pParent->NotifyDecideKey( this, GetCurPos() );
	}
}
//-----------------------------------------------------------------------------
// SetCurPos
//-----------------------------------------------------------------------------
int CEquipCharWindow::SetCurPos( int nIndex )
{
	int nRet = CMenuWindow::SetCurPos( nIndex );
	m_pParent->NotifyCurPosChange( this, GetCurPos() );

	return nRet;
}
//-----------------------------------------------------------------------------
// Render
//-----------------------------------------------------------------------------
void CEquipCharWindow::Render( void )
{
	CFrameWindow::Render();

	CPlayerChar *pPlayer = m_pPlayerParty->GetPlayer( m_pParent->GetSelectedPlayerIndex() );
	if ( !pPlayer )
		return;
	const CEquipItem *pItem;

	const int BASE_POS_X1 = m_nPosX + 6;
	const int BASE_POS_X2 = m_nPosX + 100;
	const int BASE_POS_X3 = m_nPosX + 210;
	const int BASE_POS_Y  = m_nPosY + 20;

	// E
	DrawString( BASE_POS_X1, BASE_POS_Y +  0, "݂", STRING_COLOR );
	pItem = pPlayer->GetEquipItem( CHR_POS_DOMINANT );
	if ( pItem->nID == 0 && pPlayer->IsNoWeapon() )
		DrawString( BASE_POS_X2, BASE_POS_Y +  0, "", STRING_COLOR );
	else
		DrawString( BASE_POS_X2, BASE_POS_Y +  0, pItem->szName, STRING_COLOR );
		

	// 
	DrawString( BASE_POS_X1, BASE_POS_Y + 12, "Ђ", STRING_COLOR );
	pItem = pPlayer->GetEquipItem( CHR_POS_NON_DOMINANT );
	if ( pItem->nID == 0 && pPlayer->IsNoWeapon() )
		DrawString( BASE_POS_X2, BASE_POS_Y + 12, "", STRING_COLOR );		
	else
		DrawString( BASE_POS_X2, BASE_POS_Y + 12, pItem->szName, STRING_COLOR );

	// 
	DrawString( BASE_POS_X1, BASE_POS_Y + 26, "", STRING_COLOR );
	pItem = pPlayer->GetEquipItem( CHR_POS_HEAD );
	DrawString( BASE_POS_X2, BASE_POS_Y + 26, pItem->szName, STRING_COLOR );

	// 
	DrawString( BASE_POS_X1, BASE_POS_Y + 38, "炾", STRING_COLOR );
	pItem = pPlayer->GetEquipItem( CHR_POS_BODY );
	DrawString( BASE_POS_X2, BASE_POS_Y + 38, pItem->szName, STRING_COLOR );

	// ANZT
	DrawString( BASE_POS_X1, BASE_POS_Y + 50, "ANZT", STRING_COLOR );
	pItem = pPlayer->GetEquipItem( CHR_POS_ACCESSORY1 );
	DrawString( BASE_POS_X2, BASE_POS_Y + 50, pItem->szName, STRING_COLOR );


	// G
	m_pPlayerParty->RenderPortrait( m_pParent->GetSelectedPlayerIndex(), BASE_POS_X3, BASE_POS_Y  );

	// O
	DrawString( BASE_POS_X3 + 35, BASE_POS_Y + 0, pPlayer->m_CharInfo.szName, STRING_COLOR );

	// Wu
	DrawString( BASE_POS_X3 + 35, BASE_POS_Y + 12, CDataManager::GetInstance()->GetJobName( pPlayer->m_CharInfo.nJobID ), STRING_COLOR );

	// \ACR
	DrawString( BASE_POS_X3, BASE_POS_Y + 28, "", STRING_COLOR );

	// J[\`
	if ( m_bFocused  )
	{
		m_pCursor->Render();
	}
}
