//=============================================================================
// EquipWindow.cpp
//=============================================================================
#include "Stdinc.h"
#include "EquipWindow.h"
#include "Manipulator.h"
#include "PlayerParty.h"
#include "CampWindow.h"
//-----------------------------------------------------------------------------
// RXgN^
//-----------------------------------------------------------------------------
CEquipWindow::CEquipWindow(void)
	:m_nSelCharPos( CHR_POS_DOMINANT )
{
}

//-----------------------------------------------------------------------------
// fXgN^
//-----------------------------------------------------------------------------
CEquipWindow::~CEquipWindow(void)
{
}

//-----------------------------------------------------------------------------
// 
//-----------------------------------------------------------------------------
BOOL CEquipWindow::Create( CPlayerParty *pPlayerParty, CCampWindow *pParent )
{
	m_pPlayerParty = pPlayerParty;
	m_pCampWnd = pParent;

	// LN^EBhE
	m_CharWnd.Create( 0, 0, 320, 85, pPlayerParty, this );
	m_lstCoWindow.push_back( &m_CharWnd );

	// ACeXg
	m_ItemWnd.Create( 0, 85, 150, 155, pPlayerParty, this );	// ʒm
	m_lstCoWindow.push_back( &m_ItemWnd );

	// p^\
	m_ParamWnd.Create( 150, 85, 170, 155, pPlayerParty, this );
	m_lstCoWindow.push_back( &m_ParamWnd );

	// wb_j[
	m_MenuWnd.Create( 0, 0, 320, 18, this );	// ʒm
	m_lstCoWindow.push_back( &m_MenuWnd );

	// uсv\
	m_TagWnd.Create( 250, 0, 70, 19 );
	m_TagWnd.SetTagName("");
	m_TagWnd.SetTopMargin( 4 );
	m_TagWnd.SetLeftMargin( 16 );
	m_lstCoWindow.push_back( &m_TagWnd );

	return TRUE;
}
//-----------------------------------------------------------------------------
// XV
//-----------------------------------------------------------------------------
void CEquipWindow::FrameMove( const CManipulator *pMani )
{
	if ( !IsVisible() )
		return;

	CCoWndManager::FrameMove( pMani );
}
//-----------------------------------------------------------------------------
// `
//-----------------------------------------------------------------------------
void CEquipWindow::Render( void )
{
	if ( !IsVisible() )
		return;

	CCoWndManager::Render();
}

//-----------------------------------------------------------------------------
// j
//-----------------------------------------------------------------------------
void CEquipWindow::Delete( void )
{
}
//-----------------------------------------------------------------------------
// SetVisible
//-----------------------------------------------------------------------------
void CEquipWindow::SetVisible( BOOL bFlag )
{
	CCoWndManager::SetVisible( bFlag );
	if ( bFlag )
	{
		m_TagWnd.SetVisible( FALSE );
		m_MenuWnd.SetVisible( TRUE );
		m_ItemWnd.ClearMenuItem();
		ChangeFocus( &m_MenuWnd );
	}
}
//-----------------------------------------------------------------------------
// qEBhẼj[ʒm
// NotifyDecideKey
//-----------------------------------------------------------------------------
void CEquipWindow::NotifyDecideKey( CFrameWindow *pWnd, int nMenuID )
{
	if ( pWnd == &m_MenuWnd )
	{
		switch ( nMenuID )
		{
		case CEquipMenuWindow::MENU_ID_EQUIP:		// 
			m_TagWnd.SetVisible( TRUE );
			m_MenuWnd.SetVisible( FALSE );
			ChangeFocus( &m_CharWnd );
			m_ItemWnd.UpdateDispItem();
			break;
		case CEquipMenuWindow::MENU_ID_AUTO:		// 傤
			BestEquipProc();
			break;
		case CEquipMenuWindow::MENU_ID_REMOVE:		// ͂
			m_ItemWnd.ClearMenuItem();

			m_TagWnd.SetVisible( TRUE );
			m_MenuWnd.SetVisible( FALSE );
			ChangeFocus( &m_CharWnd );

			break;
		case CEquipMenuWindow::MENU_ID_REMOVE_ALL:	// ׂĂ͂
			AllRemoveProc();
			break;
		case CEquipMenuWindow::MENU_ID_FINISH:		// 
			SetVisible( FALSE );
			// Lvj[ɖ߂
			m_pCampWnd->SetVisible( TRUE );
			break;
		}
	}
	else if ( pWnd == &m_CharWnd )
	{
		if ( m_MenuWnd.GetCurPos() == CEquipMenuWindow::MENU_ID_EQUIP )
		{	// 

			if ( m_ItemWnd.GetItemCount() == 0 )
				return;	// ł̂Ȃ

			ChangeFocus( &m_ItemWnd );
		}
		else if ( m_MenuWnd.GetCurPos() == CEquipMenuWindow::MENU_ID_REMOVE )
		{
			CPlayerChar *pPlayer = m_pPlayerParty->GetPlayer( GetSelectedPlayerIndex() );
			if ( pPlayer )
			{
				// ͂
				pPlayer->RemoveEquipItem( GetSelectedCharPos() );
			}

		}
	}
	else if ( pWnd == &m_ItemWnd )
	{
		// ToDo: AreBWuɂđłȂ̂͂H

		// XV
		if ( m_ItemWnd.GetSelectedItem() != NULL )
		{
			CPlayerChar *pPlayer = m_pPlayerParty->GetPlayer( GetSelectedPlayerIndex() );
			if ( pPlayer )
			{
				// Ă̂ ̂
				pPlayer->RemoveEquipItem( GetSelectedCharPos() );

				// Î𑕔
				CEquipItem *pNewEquip = (CEquipItem *)m_ItemWnd.GetSelectedItem();
				pPlayer->SetEquipItem( pNewEquip, m_CharWnd.GetCurPos() );
			}
		}
		ChangeFocus( &m_CharWnd );
		m_ItemWnd.UpdateDispItem();
	}
}
//-----------------------------------------------------------------------------
// ׂĂ͂
// AllRemoveProc
//-----------------------------------------------------------------------------
void CEquipWindow::AllRemoveProc( void )
{
	CPlayerChar *pPlayer = m_pPlayerParty->GetPlayer( GetSelectedPlayerIndex() );
	if ( !pPlayer )
		return;
	for ( int iCnt = 0; iCnt < CHR_POS_MAX; iCnt ++ )
	{
		// ͂
		pPlayer->RemoveEquipItem( iCnt );
	}
}
//-----------------------------------------------------------------------------
// 傤
// BestEquipProc
//-----------------------------------------------------------------------------
void CEquipWindow::BestEquipProc( void )
{
	CPlayerChar *pPlayer = m_pPlayerParty->GetPlayer( GetSelectedPlayerIndex() );
	if ( !pPlayer )
		return;

	std::vector<stItemInfo *> lstItemInfo;	// \ACe

	for ( int iCnt = 0; iCnt < CHR_POS_MAX; iCnt ++ )
	{
		// ͂
		pPlayer->RemoveEquipItem( iCnt );

		// ŋT
		m_pPlayerParty->GetEquipableItemList( pPlayer->m_CharInfo.nJobID, iCnt, lstItemInfo );
		CEquipItem *pNewEquip = GetBestEquip( lstItemInfo );

		if ( !pNewEquip )
			continue;

		// Î𑕔
		pPlayer->SetEquipItem( pNewEquip, iCnt );
	}
}
//-----------------------------------------------------------------------------
// GetBestEquip
//-----------------------------------------------------------------------------
CEquipItem *CEquipWindow::GetBestEquip( std::vector<stItemInfo *> &lstItemInfo )
{
	int nMaxValue = 0;
	CEquipItem *pBestEquip = NULL;
	for ( int iCnt = 0; iCnt < (int)lstItemInfo.size(); iCnt ++ )
	{
		stItemInfo *pInfo = lstItemInfo.at( iCnt );
		CEquipItem *pEquip = (CEquipItem *)pInfo->pItem;
		if ( pEquip->nEquipPos <= EQUIP_POS_TWOHAND )
		{	// 
			if ( nMaxValue < pEquip->Param.nAttack )
			{
				nMaxValue = pEquip->Param.nAttack;
				pBestEquip = pEquip;
			}
		}
		else
		{	// h
			if ( nMaxValue < pEquip->Param.nDefence )
			{
				nMaxValue = pEquip->Param.nDefence;
				pBestEquip = pEquip;
			}
		}
	}
	return pBestEquip;
}
//-----------------------------------------------------------------------------
// qEBhẼLZ{^ʒm
// NotifyCancelKey
//-----------------------------------------------------------------------------
void CEquipWindow::NotifyCancelKey( CFrameWindow *pWnd )
{
	if ( pWnd == &m_MenuWnd )
	{
		SetVisible( FALSE );
		// Lvj[ɖ߂
		m_pCampWnd->SetVisible( TRUE );
	}
	else if ( pWnd == &m_CharWnd )
	{
		m_TagWnd.SetVisible( FALSE );
		m_MenuWnd.SetVisible( TRUE );
		ChangeFocus( &m_MenuWnd );
		m_ItemWnd.ClearMenuItem();
	}
	else if ( pWnd == &m_ItemWnd )
	{
		ChangeFocus( &m_CharWnd );
		m_ItemWnd.UpdateDispItem();
	}
}
//-----------------------------------------------------------------------------
// qEBhẼJ[\ʒuύXʒm
//-----------------------------------------------------------------------------
void CEquipWindow::NotifyCurPosChange( CFrameWindow *pWnd, int nMenuID )
{
	if ( pWnd == &m_CharWnd )
	{	// I𕔈ʐݒ
		m_nSelCharPos = nMenuID;

		if ( m_MenuWnd.GetCurPos() == CEquipMenuWindow::MENU_ID_EQUIP )
		{
			m_ItemWnd.UpdateDispItem();
		}
		else
		{
			m_ItemWnd.ClearMenuItem();
		}
	}
}
