//=============================================================================
// EquipWindow.h
//=============================================================================
#pragma once
#include <assert.h>
#include "cowndmanager.h"
#include "TagWindow.h"
#include "EquipMenuWindow.h"
#include "EquipCharWindow.h"
#include "EquipItemListWindow.h"
#include "EquipParamWindow.h"

class CPlayerParty;
class CManipulator;
class CCampWindow;
//-----------------------------------------------------------------------------
// CEquipWindow
//-----------------------------------------------------------------------------
class CEquipWindow : public CCoWndManager
{
private:
	BOOL Create( void ){ assert(0); return FALSE;	};	// don't use

protected:
	CCampWindow				*m_pCampWnd;		// eEBhE
	CPlayerParty			*m_pPlayerParty;

	// qEBhE
	CTagWindow				m_TagWnd;			//  \
	CEquipMenuWindow		m_MenuWnd;			// j[
	CEquipCharWindow		m_CharWnd;			// LN^EBhE
	CEquipItemListWindow	m_ItemWnd;			// ACeXg
	CEquipParamWindow		m_ParamWnd;			// p^EBhE

	int						m_nSelPlayer;		// Iꂽv[
	int						m_nSelCharPos;		// Iꂽʒu

	void AllRemoveProc( void );
	void BestEquipProc( void );

	CEquipItem *GetBestEquip( std::vector<stItemInfo *> &lstItemInfo );
public:
	CEquipWindow(void);
	virtual ~CEquipWindow(void);

	BOOL IsMenu( void ) const	// j[邩
	{	return TRUE;	};

	void SetVisible( BOOL bFlag );

	void SetSelectedPlayerIndex( int nIndex )
	{	m_nSelPlayer = nIndex;	};

	int GetSelectedPlayerIndex( void ) const
	{	return m_nSelPlayer;	};

	void SetSelectedCharPos( int nPos )
	{	m_nSelCharPos = nPos;	};

	int GetSelectedCharPos( void ) const
	{	return m_nSelCharPos;	};

	CEquipItem *GetSelectedListItem( void )
	{
		if ( !m_ItemWnd.IsFocused() )
			return NULL;

		return (CEquipItem *)m_ItemWnd.GetSelectedItem();	
	};


	BOOL Create( CPlayerParty *pPlayerParty, CCampWindow *pParent );	// 
	void FrameMove( const CManipulator *pMani ); 	// XV
	void Render( void );		// `
	void Delete( void );		// j

	// qEBhẼj[ʒm
	void NotifyDecideKey( CFrameWindow *pWnd, int nMenuID );
	// qEBhẼLZ{^ʒm
	void NotifyCancelKey( CFrameWindow *pWnd );
	// qEBhẼJ[\ʒuύXʒm
	void NotifyCurPosChange( CFrameWindow *pWnd, int nMenuID );
};

