//=============================================================================
// Game.h
//=============================================================================
#pragma once
#include <list>

#include "MapManager.h"
#include "Manipulator.h"
#include "PlayerParty.h"
#include "MsgWindow.h"
#include "Effect.h"
#include "Flag.h"
#include "Cursor.h"
#include "CampWindow.h"
#include "StoreWindow.h"
#include "Battle.h"
#include "SoundManager.h"
#include "YesNoMsgWindow.h"
#include "ChoiceMsgWindow.h"
#include "EncountManager.h"


class CDrawable;
class CMapObject;
//-----------------------------------------------------------------------------
// CGame
//-----------------------------------------------------------------------------
class CGame
{
public:
	enum {
		ENCOUNT_ENEMY_RANDUM = 0,
	};

private:
	CGame(void);
	virtual ~CGame(void);

protected:
	std::list<int>	m_lstMode;
	int				m_nWaitStatus;	// ҂Ă邩
	int				m_nEnemyPartyID;// GJEgGp[eB
	BOOL			m_bEventBattle;

	time_t			m_timStartTime;		// Jn
	time_t			m_timLastPlayTime;	// OJn
	time_t			m_timPlayTime;		// vC

	// eǗNX
	CMapManager		m_Map;			// n}
	CBattle			m_Battle;		// 퓬
	CEncountManager	m_Encount;		// GJEgǗ
	CManipulator	m_Mani;			// 
	CSoundManager	m_Sound;		// TEh
	CPlayerParty	m_PlayerParty;	// v[
	CEffect			m_Effect;		// GtFNg
	CFlag			m_Flag;			// Q[tOǗ
	CCursor			m_Cursor;		// J[\
	CCampWindow		m_wndCamp;		// LvEBhE
	CStoreWindow	m_wndStore;		// XEBhE

	CMsgWindow		m_wndMsg;		// bZ[WEBhE
	CYesNoMsgWindow m_wndYesNo;		// YES/NO bZ[WEBhE
	CChoiceMsgWindow m_wndChoice;	// EBhE
	int				m_nLastAnswer;	// YesNo/EBhEőI

	// }bvؑ֗v
	stMapChangeReqParam		m_MapChangeReqParam;
	// }bvړv
	stMapMoveReqParam		m_MapMoveReqParam;

	// IuWFNgړv
	CMapObject				*m_pMapObjMoveReqTgt;
	// t[JE^҂v
	int						m_nWaitFrame;

	void FrameMove_ModeMap( void );
	void ChangeDirToPlayer( CMapObject *pMapObj );
	void ChangeMap( stMapChangeReqParam *pPram );
	void UpdatePlayTime( void );

	void StartBattle( void );

	// ToDo
	void DEBUG_init( void );
	void DEBUG_SetupHPMP( CPlayerChar *pPlayer );

public:
	static CGame *GetInstance( void );
	CCursor *GetCursor( void )
	{	return &m_Cursor;	};

	BOOL Initialize( void );	// 
	void Finalize( void );		// I

	void FrameMove( void );		// XV

	void Render( void );		// `
	void RenderToTargetScreen( void );	// ^[QbgT[tF[Xɕ`

	int GetMapID( void ) const
	{	return m_Map.GetID();	};

	// Q[[h
	int GetMode( void );		// ݂̃[h擾
	void SetMode( int nMode );	// [hX^bNNAĐݒ
	void PushMode( int nMode );	// [hX^bNɃvbV
	int PopMode( void );		// [hX^bN|bv

	// Z[u\
	BOOL CanSaveNow( void );

	// vCԎ擾
	time_t GetPlayTime( void ) const
	{	return m_timPlayTime;	};

	// 擾
	UINT GetGill( void )
	{	return m_PlayerParty.GetGill();	};

	// ҂
	int GetWaitStatus( void )
	{	return m_nWaitStatus;	};

	void SetWaitStatus( int nWaitStatus )
	{
		//LOG_OUTPUT( "WaitSts [%d] -> [%d]\n", m_nWaitStatus, nWaitStatus );
		m_nWaitStatus = nWaitStatus;	
	};

	// GtFNg
	int GetOffsetX( void ) const
	{	return m_Effect.GetShakeOffsetX();	};
	int GetOffsetY( void ) const
	{	return m_Effect.GetShakeOffsetY();	};

	// 퓬Jn
	void Encount( int nEnemyPartyID );
	void StartEventBattle( int nEnemyPartyID );
	// 퓬Iʒm
	void FinishedBattle( void );

	// }bv}l[WANZbT
	CMapManager *GetMapMan( void )
	{	return &m_Map;	};

	// XNvgJnv
	void StartScriptRequest( CMapObject *pMapObj );

	// LuaR[obNp
	void ShowMessage( const char *lpzMessage );
	void CloseMessage( void );
	void AddMessage( const char *lpzMessage );
	void StartFadeout( DWORD dwColor, UINT nFrame );
	void StartFadein( DWORD dwColor, UINT nFrame );
	void StartShake( int nType, UINT nFrame, double dblSpeed, int nScale );
	void ChangeMapRequest( int nMapID, int nLocX, int nLocY, int nPlayerDir );
	char GetTreasureFlag( int nMapID, int nEventID, int *pIndex = NULL );
	void GetTreasure( int nMapID, int nEventID, CItem **pItem );
	void MovePlayer( int nDirection, int nSpeed );
	void MoveMapObject( int nEventID, int nDirection, int nSpeed );
	void WaitFrame( int nFrame );
	void OpenStore( int nType, int nMsgPtn, int nRate, int nItemCount, int *pItemID );
	void LoadSoundFile( int nID );
	void PlayBGM( int nID, BOOL bTopPositionFlag );
	void StopBGM( void );
	char GetGameFlag( int nIndex );
	void SetGameFlag( int nIndex, char chValue );
	void ShowYesNoMessage( const char *lpzMessage );
	void ShowChoiceMessage( const char *lpzQuestion, const char *lpzAns1, const char *lpzAns2, const char *lpzAns3 );
	int GetYesNoAnswer( void );
	int GetChooseAnswer( void );

};
