//=============================================================================
// ItemListWindow.cpp
//=============================================================================
#include "Stdinc.h"
#include "ItemListWindow.h"
#include "PlayerParty.h"
#include "Item.h"
#include "Manipulator.h"
#include "CoWndManager.h"
//-----------------------------------------------------------------------------
// RXgN^
//-----------------------------------------------------------------------------
CItemListWindow::CItemListWindow(void)
	: m_bSelected( FALSE ), m_nMode( ITEM_LIST_MODE_NORMAL )
{
	m_nPageItemCount = ONE_PAGE_ITEM_COUNT;			// 1y[W 20ACe
	CMenuWindow::m_nType = MENU_TYPE_HORIZONTAL;	// ^j[
}

//-----------------------------------------------------------------------------
// fXgN^
//-----------------------------------------------------------------------------
CItemListWindow::~CItemListWindow(void)
{
}
//-----------------------------------------------------------------------------
// Create
//-----------------------------------------------------------------------------
BOOL CItemListWindow::Create( int iPosX, int iPosY, int iWidth, int iHeight, CPlayerParty *pParty, CCoWndManager *pParent )
{
	BOOL bRet = CListWindow::Create( iPosX, iPosY, iWidth, iHeight );

	m_pParent = pParent;
	m_pPlayerParty = pParty;

	// _~[ACeǉ
	const int BASE_POS_X1 =  30;
	const int BASE_POS_X2 = 170;
	const int BASE_POS_Y  =  10;
	const int INCREMENT_Y =  15;

	for ( int iCnt = 0; iCnt < ONE_PAGE_ITEM_COUNT; iCnt ++ )
	{
		stMenuItem Item;
		Item.nID = iCnt;
		Item.bEnabled = TRUE;

		// ʒu
		if ( iCnt % 2 == 0 )
			Item.nPosX = BASE_POS_X1;
		else
			Item.nPosX = BASE_POS_X2;
		Item.nPosY = INCREMENT_Y * (iCnt / 2) + BASE_POS_Y;
		Item.lpzText = "ACe";
		Item.nIcon = 0;
		Item.nCount = 0;

		AddMenuItem( &Item );
	}

	return bRet;
}
//-----------------------------------------------------------------------------
// SetVisible
//-----------------------------------------------------------------------------
void CItemListWindow::SetVisible( BOOL bFlag )
{
	CListWindow::SetVisible( bFlag );
	if ( bFlag )
	{
		// J[\ʒu
		m_nTopItemIndex = 0;

		// ACeXgݒ
		UpdateDispItem();
	}
}

//-----------------------------------------------------------------------------
// FrameMove
//-----------------------------------------------------------------------------
void CItemListWindow::FrameMove( const CManipulator *pMani )
{
	if ( !m_bFocused )
		return;
	if ( !IsVisible() )
		return;

	int nLastTopItemIndex = m_nTopItemIndex;

	// L[ 2΂
	if ( pMani->CheckKey( KEY_INPUT_DOWN ) )
	{
		if ( m_nCursorIndex < (int)m_aryItem.size() - 2 )
		{
			SetCurPos( m_nCursorIndex + 2 );
		}
		// 1ԉ̍s
		else if ( m_nTopItemIndex + m_nPageItemCount < m_nMaxItemCount )
		{	// XN[
			m_nTopItemIndex += 2;
		}
	}
	// L[ 2΂
	if ( pMani->CheckKey( KEY_INPUT_UP ) )
	{
		if ( 1 < m_nCursorIndex )
		{
			SetCurPos( m_nCursorIndex - 2 );
		}
		// 1ԏ̍s
		else if ( 1 < m_nTopItemIndex )
		{	// XN[
			m_nTopItemIndex -= 2;
		}
	}

	// EL[
	if ( pMani->CheckKey( KEY_INPUT_RIGHT ) )
	{
		// 1ԉ̍s
		if ( (int)m_aryItem.size() - 1 == m_nCursorIndex )
		{
			if ( m_nTopItemIndex + m_nPageItemCount < m_nMaxItemCount )
			{	// XN[
				m_nTopItemIndex += 2;
				SetCurPos( m_nCursorIndex - 2 );	// ̌ CListWindow::FrameMove +1鎖҂Ă
			}
		}
	}
	// L[
	if ( pMani->CheckKey( KEY_INPUT_LEFT ) )
	{
		// 1ԏ̍s
		if ( m_nCursorIndex == 0 )
		{
			if ( 1 < m_nTopItemIndex )
			{	// XN[
				m_nTopItemIndex -= 2;
				SetCurPos( m_nCursorIndex + 2 );	// ̌ CListWindow::FrameMove -1鎖҂Ă
			}
		}
	}

	CListWindow::FrameMove( pMani );

	// LZL[
	if ( pMani->CheckKey( KEY_INPUT_Z ) )
	{
		if ( m_bSelected )
		{	// IĂ
			m_pCursor->RemoveAllSelectedPos();	// IԏI
			m_bSelected = FALSE;
			return;
		}
		else
		{
			m_pParent->NotifyCancelKey( this );
		}
	}
	// L[
	else if ( pMani->CheckKey( KEY_INPUT_X ) )
	{
		if ( !m_bFocused )
			return;
		if ( !m_bSelected )
		{	// IĂȂ  IԂ
			m_bSelected = TRUE;
			m_nSelItem = GetCurPos() + m_nTopItemIndex;

			// IJ[\`ʒuǉ
			stMenuItem *pItem = GetItem( GetCurPos() );
			m_pCursor->AddSelectedPos( m_nPosX + pItem->nPosX-12, m_nPosY + pItem->nPosY-3 );
		}
		else
		{	// IĂ
			ProcDecideKey();
			m_pCursor->RemoveAllSelectedPos();	// IԏI
			m_bSelected = FALSE;
		}
	}

	if ( m_nTopItemIndex != nLastTopItemIndex )
	{	// XN[Ă\ACeXV
		UpdateDispItem();
	}
}
//-----------------------------------------------------------------------------
// ProcDecideKey
//-----------------------------------------------------------------------------
void CItemListWindow::ProcDecideKey( void )
{
	if ( m_nSelItem == GetCurPos() )
	{	// IJnƓƂŌL[  ACegpʒm
		m_pParent->NotifyDecideKey( this, m_nTopItemIndex + GetCurPos() );
	}
	else
	{	// IJnƈႤƂŌL[  ACeʒuւ
		m_pPlayerParty->SwapItem( m_nSelItem, m_nTopItemIndex + GetCurPos() );
	}
	UpdateDispItem();
}

//-----------------------------------------------------------------------------
// Render
//-----------------------------------------------------------------------------
void CItemListWindow::Render( void )
{
	if ( !IsVisible() )
		return;

#if 0	// for debug
	CListWindow::Render();
#else
	CListWindow::Render();

	for ( int iCnt = 0; iCnt < (int)m_aryItem.size(); iCnt ++ )
	{
		DWORD dwColor;
		stMenuItem *pItem = m_aryItem.at( iCnt );
		if ( pItem->bEnabled )
		{
			dwColor = STRING_COLOR;
		}
		else
		{
			dwColor = DISABLED_STRING_COLOR;
		}
		
		if ( pItem->nCount )
		{
			// ACRE
			DrawString( m_nPosX + pItem->nPosX + 8, m_nPosY + pItem->nPosY, pItem->lpzText, dwColor );

			// `
			char szBuff[64];
			sprintf_s( szBuff, sizeof(szBuff), ": %2d", pItem->nCount );
			DrawString( m_nPosX + pItem->nPosX + 95, m_nPosY + pItem->nPosY, szBuff, dwColor );
		}
	}

	// J[\`
	if ( m_bFocused  )
	{
		if ( m_bSelected )
		{	// I _ŃJ[\`
			m_pCursor->RenderSelectedCursor();
		}
		m_pCursor->Render();
	}
#endif	// for debug end
}
//-----------------------------------------------------------------------------
// UpdateDispItem
// \ACeXV
//-----------------------------------------------------------------------------
void CItemListWindow::UpdateDispItem( void )
{
	m_pCursor->RemoveAllSelectedPos();	// S폜

	if ( m_nMode == ITEM_LIST_MODE_NORMAL )
	{	// ʏACe

		for ( int iCnt = 0; iCnt < (int)m_aryItem.size(); iCnt ++ )
		{
			int nIndex = m_nTopItemIndex + iCnt;
			stItemInfo *pItem = m_pPlayerParty->GetItemInfo( nIndex );

			if ( pItem == NULL )
			{	// ACeɍXV
				UpdateMenuText( iCnt, TRUE, "", 0, 0 );
			}
			else
			{
				char szDispText[64];
				sprintf_s( szDispText, sizeof(szDispText), "%s",pItem->pItem->szName );
				UpdateMenuText( iCnt, TRUE, szDispText, 0, pItem->nCount );

				// ACe̓O[
				EnableMenuItem( iCnt, ! CEquipItem::IsEquipItem( pItem->pItem->nID ) );
			}
			// _ŃJ[\ʒuXV
			if ( m_bSelected && m_nSelItem == nIndex )
			{
				stMenuItem *pMenuItem = m_aryItem.at(iCnt);
				m_pCursor->AddSelectedPos( m_nPosX + pMenuItem->nPosX-12, m_nPosY + pMenuItem->nPosY-3 );
			}
		}
	}
	else
	{	// Ȃ
		for ( int iCnt = 0; iCnt < (int)m_aryItem.size(); iCnt ++ )
		{
			UpdateMenuText( iCnt, TRUE, "", 0, 0 );
		}
	}
}
