//=============================================================================
// ItemPartyWindow.cpp
//=============================================================================
#include "Stdinc.h"
#include "ItemPartyWindow.h"
#include "PlayerParty.h"
#include "Item.h"
#include "Manipulator.h"
#include "DataManager.h"
#include "ItemWindow.h"
//-----------------------------------------------------------------------------
// RXgN^
//-----------------------------------------------------------------------------
CItemPartyWindow::CItemPartyWindow(void)
{
	m_nType = MENU_TYPE_VERTICAL;	// c^j[
	m_bLoopAtEdge = TRUE;			// ACen_ƏI_q
}

//-----------------------------------------------------------------------------
// fXgN^
//-----------------------------------------------------------------------------
CItemPartyWindow::~CItemPartyWindow(void)
{
}
//-----------------------------------------------------------------------------
// Create
//-----------------------------------------------------------------------------
BOOL CItemPartyWindow::Create( int iPosX, int iPosY, int iWidth, int iHeight, CPlayerParty *pParty, CItemWindow *pParent )
{
	BOOL bRet = CMenuWindow::Create( iPosX, iPosY, iWidth, iHeight );

	m_pParent = pParent;
	m_pPlayerParty = pParty;

	// _~[ACeǉ
	const stMenuItem PARTY_MENU_ITEM[] = {
		{   0,  TRUE, 10,  13, "", 0, 0 },
		{   1,  TRUE, 10,  53, "", 0, 0 },
		{   2,  TRUE, 10,  93, "", 0, 0 },
		{   3,  TRUE, 10, 133, "", 0, 0 },
	};

	// ACeǉ
	for ( int iCnt = 0; iCnt < sizeof( PARTY_MENU_ITEM ) / sizeof( PARTY_MENU_ITEM[0] ); iCnt ++ )
	{
		AddMenuItem( &PARTY_MENU_ITEM[iCnt] );
	}

	SetCurPos( 0 );

	return bRet;
}
//-----------------------------------------------------------------------------
// FrameMove
//-----------------------------------------------------------------------------
void CItemPartyWindow::FrameMove( const CManipulator *pMani )
{
	if ( !m_bFocused )
		return;
	if ( !IsVisible() )
		return;

	CMenuWindow::FrameMove( pMani );

	// J[\ʒuɃLȂ΂炷
	while ( 1 )
	{
		int nIndex = GetCurPos();
		if ( m_pPlayerParty->GetPlayer( nIndex ) )
			break;

		if ( pMani->CheckKey( KEY_INPUT_UP ) )
			nIndex --;
		else
			nIndex ++;
		if ( m_pPlayerParty->GetPlayerCount() <= nIndex ) 
			nIndex = 0;

		SetCurPos( nIndex );
	}

	// LZL[
	if ( pMani->CheckKey( KEY_INPUT_Z ) )
	{
		m_pParent->NotifyCancelKey( this );
	}
	// L[
	else if ( pMani->CheckKey( KEY_INPUT_X ) )
	{
		m_pParent->NotifyDecideKey( this, GetCurPos() );
	}

}
//-----------------------------------------------------------------------------
// Render
//-----------------------------------------------------------------------------
void CItemPartyWindow::Render( void )
{
	if ( !IsVisible() )
		return;

	CMenuWindow::Render();


	const int BASE_POS_Y_0 =  6 + m_nPosY;
	const int BASE_POS_Y_1 = 46 + m_nPosY;
	const int BASE_POS_Y_2 = 86 + m_nPosY;
	const int BASE_POS_Y_3 =126 + m_nPosY;
	// LGʒu
	const POSITION PosPortrait[] = {
		{	m_nPosX + 15, BASE_POS_Y_0 + 3 },
		{	m_nPosX + 15, BASE_POS_Y_1 + 3 },
		{	m_nPosX + 15, BASE_POS_Y_2 + 3 },
		{	m_nPosX + 15, BASE_POS_Y_3 + 3 },
	};
	// Oʒu
	const POSITION PosName[] = {
		{	m_nPosX + 45, BASE_POS_Y_0 },
		{	m_nPosX + 45, BASE_POS_Y_1 },
		{	m_nPosX + 45, BASE_POS_Y_2 },
		{	m_nPosX + 45, BASE_POS_Y_3 },
	};
	// LVʒu
	const POSITION PosLv[] = {
		{	m_nPosX + 210, BASE_POS_Y_0 },
		{	m_nPosX + 210, BASE_POS_Y_1 },
		{	m_nPosX + 210, BASE_POS_Y_2 },
		{	m_nPosX + 210, BASE_POS_Y_3 },

	};
	// Wuʒu
	const POSITION PosJobName[] = {
		{	m_nPosX + 45, BASE_POS_Y_0 + 24 },
		{	m_nPosX + 45, BASE_POS_Y_1 + 24 },
		{	m_nPosX + 45, BASE_POS_Y_2 + 24 },
		{	m_nPosX + 45, BASE_POS_Y_3 + 24 },
	};

	// HPʒu
	const POSITION PosHp[] = {
		{  m_nPosX + 162, BASE_POS_Y_0 + 12 },
		{  m_nPosX + 162, BASE_POS_Y_1 + 12 },
		{  m_nPosX + 162, BASE_POS_Y_2 + 12 },
		{  m_nPosX + 162, BASE_POS_Y_3 + 12 },
	};
	// MPʒu
	const POSITION PosMp[] = {
		{  m_nPosX + 162, BASE_POS_Y_0 + 24 },
		{  m_nPosX + 162, BASE_POS_Y_1 + 24 },
		{  m_nPosX + 162, BASE_POS_Y_2 + 24 },
		{  m_nPosX + 162, BASE_POS_Y_3 + 24 },
	};
	
	CDataManager *pDataMan = CDataManager::GetInstance();
	const char *lpzText;
	char szBuff[64];
	// p[eB`
	for ( int iCnt = 0; iCnt < m_pPlayerParty->GetPlayerCount(); iCnt ++ )
	{
		CPlayerChar *pPlayer = m_pPlayerParty->GetPlayer(iCnt);
		if ( !pPlayer )
			continue;

		// LG
		m_pPlayerParty->RenderPortrait( iCnt, PosPortrait[iCnt].nPosX, PosPortrait[iCnt].nPosY );		// Oq

		// O
		lpzText = pPlayer->m_CharInfo.szName;
		if ( strlen(lpzText) == 0 )
			lpzText = "?";
		DrawString( PosName[iCnt].nPosX, PosName[iCnt].nPosY, lpzText, STRING_COLOR );

		// x
		sprintf_s( szBuff, "ku %4d" ,pPlayer->m_CharInfo.nLV );	lpzText = szBuff;
		DrawString( PosLv[iCnt].nPosX, PosLv[iCnt].nPosY, lpzText, STRING_COLOR );

		// Wu
		lpzText = pDataMan->GetJobName( pPlayer->m_CharInfo.nJobID );
		DrawString( PosJobName[iCnt].nPosX, PosJobName[iCnt].nPosY, lpzText, STRING_COLOR );

		// HP
		sprintf_s( szBuff, "go@%4d ^ %4d" ,pPlayer->m_CharInfo.nHP, pPlayer->m_BasePram.nMaxHP );	lpzText = szBuff;
		//sprintf_s( szBuff, "go@9999 ^ 9999" ,pPlayer->m_CharInfo.nHP, pPlayer->m_BasePram.nMaxHP );	lpzText = szBuff;
		DrawString( PosHp[iCnt].nPosX, PosHp[iCnt].nPosY, lpzText, STRING_COLOR );

		// MP
		sprintf_s( szBuff, "lo@%4d ^ %4d" ,pPlayer->m_CharInfo.nMP, pPlayer->m_BasePram.nMaxMP );	lpzText = szBuff;
		//sprintf_s( szBuff, "lo@9999 ^ 9999" ,pPlayer->m_CharInfo.nHP, pPlayer->m_BasePram.nMaxHP );	lpzText = szBuff;
		DrawString( PosMp[iCnt].nPosX, PosMp[iCnt].nPosY, lpzText, STRING_COLOR );
	}
}
//-----------------------------------------------------------------------------
// SetTargetItem
//-----------------------------------------------------------------------------
void CItemPartyWindow::SetTargetItem( CItem *pItem )
{
	m_pItem = (CEquipItem *)pItem;
}
