//=============================================================================
// MagicCharWindow.cpp
//=============================================================================
#include "Stdinc.h"
#include "MagicCharWindow.h"
#include "MagicWindow.h"
#include "DataManager.h"
#include "PlayerParty.h"

//-----------------------------------------------------------------------------
// RXgN^
//-----------------------------------------------------------------------------
CMagicCharWindow::CMagicCharWindow(void)
{
}

//-----------------------------------------------------------------------------
// fXgN^
//-----------------------------------------------------------------------------
CMagicCharWindow::~CMagicCharWindow(void)
{
}
//-----------------------------------------------------------------------------
// 
//-----------------------------------------------------------------------------
BOOL CMagicCharWindow::Create( int iPosX, int iPosY, int iWidth, int iHeight, CPlayerParty *pParty, CMagicWindow *pParent )
{
	m_pParent = pParent;
	m_pPlayerParty = pParty;

	BOOL bRet = CFrameWindow::Create( iPosX, iPosY, iWidth, iHeight );

	return bRet;

}

//-----------------------------------------------------------------------------
// Render
//-----------------------------------------------------------------------------
void CMagicCharWindow::Render( void )
{
	CFrameWindow::Render();

	const int BASE_POS_X =  10 + m_nPosX;
	const int BASE_POS_Y =   8 + m_nPosY;

	// LG
	const POSITION PosPortrait	= { BASE_POS_X,			BASE_POS_Y };

	// Oʒu
	const POSITION PosName		= {	BASE_POS_X + 40,	BASE_POS_Y };

	// LVʒu
	const POSITION PosLv		= { BASE_POS_X + 97,	BASE_POS_Y };
	// Wuʒu
	const POSITION PosJobName	= { BASE_POS_X + 185,	BASE_POS_Y };
	// WuLvʒu
	const POSITION PosJobLv		= { BASE_POS_X + 185,	BASE_POS_Y + 12 };
	// HPʒu
	const POSITION PosHp		= { BASE_POS_X +  40,	BASE_POS_Y + 12 };
	// MPʒu
	const POSITION PosMp		= { BASE_POS_X +  40,	BASE_POS_Y + 24 };
	
	CDataManager *pDataMan = CDataManager::GetInstance();
	const char *lpzText;
	char szBuff[64];

	// `
	CPlayerChar *pPlayer = m_pPlayerParty->GetPlayer( m_pParent->GetSelectedPlayerIndex() );
	if ( !pPlayer )
		return;

	// O
	lpzText = pPlayer->m_CharInfo.szName;
	if ( strlen(lpzText) == 0 )
		lpzText = "?";
	DrawString( PosName.nPosX, PosName.nPosY, lpzText, STRING_COLOR );

	// G
	m_pPlayerParty->RenderPortrait( m_pParent->GetSelectedPlayerIndex(), PosPortrait.nPosX, PosPortrait.nPosY, CPlayerBattle::STAND );

	// x
	sprintf_s( szBuff, "ku %4d" ,pPlayer->m_CharInfo.nLV );	lpzText = szBuff;
	DrawString( PosLv.nPosX, PosLv.nPosY, lpzText, STRING_COLOR );

	// Wu
	lpzText = pDataMan->GetJobName( pPlayer->m_CharInfo.nJobID );
	DrawString( PosJobName.nPosX, PosJobName.nPosY, lpzText, STRING_COLOR );

	// WuLvʒu
	sprintf_s( szBuff, "k@%d	%4d ^ %4d" ,pPlayer->m_CharInfo.nJLV, 0, 0 );	lpzText = szBuff;
	DrawString( PosJobLv.nPosX, PosJobLv.nPosY, lpzText, STRING_COLOR );

	// HP
	sprintf_s( szBuff, "go@@%4d ^ %4d" ,pPlayer->m_CharInfo.nHP, pPlayer->m_BasePram.nMaxHP );	lpzText = szBuff;
	DrawString( PosHp.nPosX, PosHp.nPosY, lpzText, STRING_COLOR );

	// MP
	sprintf_s( szBuff, "lo@@%4d ^ %4d" ,pPlayer->m_CharInfo.nMP, pPlayer->m_BasePram.nMaxMP );	lpzText = szBuff;
	DrawString( PosMp.nPosX, PosMp.nPosY, lpzText, STRING_COLOR );
}