//=============================================================================
// MapObject.h
//=============================================================================
#pragma once
#include "characterobject.h"

class CMapManager;
//-----------------------------------------------------------------------------
// CMapObject
//-----------------------------------------------------------------------------
class CMapObject :	public CCharacterObject
{
	friend class CDataManager;
	friend class CScriptManager;

	// for debug
	friend class CMapEvent;

protected:
	int			m_nType;		// ^Cv
	int			m_nMoveType;	// ړ^Cv
	int			m_nMoveFreq;	// ړpx
	int			m_nMoveSpeed;	// ړx
	int			m_nAniSpeed;	// Aj[Vx

	WORD		m_wPassFlag;	// ʍstO
	int			m_nScriptTriger;// NgK
	lua_CFunction m_funcpExec;	// XNvg

	char		*m_lpzLuaFileName;		// XNvgt@C
	int			m_nNextMoveFrameCnt;	// ̓܂ł̃JE^


	int GetRandomMoveDir( void );
	int GetMoveFreqFrame( void );
	int GetMoveSpeedFrame( void );

public:
	CMapObject(void);
	virtual ~CMapObject(void);
	BOOL Create( int nLocX, int nLocY );		// 

	void FrameMove( CMapManager *pMapMan );
	void StartMove( int nDirection, int nMoveSpeed );

	// 쒆
	BOOL IsActing( void )
	{	return m_nMoveFrameCnt || m_nDrawOffsetX || m_nDrawOffsetY;	};	// ToDo

	int GetType( void ) const
	{	return m_nType;	};
	int GetLocationX( void ) const
	{	return m_nLocX;	}; 
	int GetLocationY( void ) const
	{	return m_nLocY;	}; 
	WORD GetPassFlag( void ) const
	{	return m_wPassFlag;	};
	int GetScriptTriger( void ) const
	{	return m_nScriptTriger;	};

	char *GetLuaFileName( void ) const
	{	return m_lpzLuaFileName;	};

	static int GetMoveType( const char *pText );
	static int GetMoveFreq( const char *pText );
	static int GetMoveSpeed( const char *pText );
	static int GetAniSpeed( const char *pText );
	static int GetType( const char *pText );
	static int GetScriptTriger( const char *pText );

};

