//=============================================================================
// PlayerBattle.cpp
//=============================================================================
#include "Stdinc.h"
#include "PlayerBattle.h"

#include "PlayerChar.h"

//-----------------------------------------------------------------------------
// RXgN^
//-----------------------------------------------------------------------------
CPlayerBattle::CPlayerBattle(void)
	:m_nAtbFrameCount( 0 ), m_nState( STAND ), m_bWaitAction( FALSE )
{
}

//-----------------------------------------------------------------------------
// fXgN^
//-----------------------------------------------------------------------------
CPlayerBattle::~CPlayerBattle(void)
{
}
//-----------------------------------------------------------------------------
// 폜
//-----------------------------------------------------------------------------
void CPlayerBattle::Delete( void )
{
	// 퓬G폜
	for ( int iCnt = 0; iCnt < BTL_CHAR_PTN_COUNT; iCnt ++ )
	{
		if ( m_nHandle[iCnt] )
		{
			DeleteGraph( m_nHandle[iCnt] );
			m_nHandle[iCnt] = 0;
		}
	}

}
//-----------------------------------------------------------------------------
// Create
//-----------------------------------------------------------------------------
BOOL CPlayerBattle::Create( int nID, int nPicID, CPlayerChar *pPlayer )
{
	m_nID = nID;
	m_nPicID = nPicID;
	m_nState = STAND;
	m_pPlayer = pPlayer;

	for ( int iCnt = 0; iCnt < BTL_CHAR_PTN_COUNT; iCnt ++ )
	{
		if ( m_nHandle[iCnt] )
		{
			DeleteGraph( m_nHandle[iCnt] );
			m_nHandle[iCnt] = 0;
		}
	}

	return LoadPicture( nPicID );
}
//-----------------------------------------------------------------------------
// [h
//-----------------------------------------------------------------------------
BOOL CPlayerBattle::LoadPicture( int nPicID )
{
	char szFileName[MAX_PATH];
	sprintf_s( szFileName, sizeof(szFileName), "%s\\%s%02d.png", CHAR_DATA_DIR , CHAR_BTL_GRAPH_FNAME_PREFIX, nPicID );

	int iRet = LoadDivGraph( szFileName , BTL_CHAR_PTN_COUNT, BTL_CHAR_PTN_COUNT, 1, 24, 24, m_nHandle );
	if ( iRet != DX_SUCCESS )
	{
		CSysUtil::Msg("摜ǂݍݎs [%s]", szFileName );
		return FALSE;
	}

	return TRUE;
}

//-----------------------------------------------------------------------------
// FrameMove
//-----------------------------------------------------------------------------
void CPlayerBattle::FrameMove( void )
{
	m_nAtbFrameCount ++;	// ATBJE^ (CNg)

	m_NumAnime.FrameMove();	// lAj[V

	if ( m_nAniFrameCount == 0 )
	{
		StopAnimation();

		// Aj[V
		if ( m_bEscapeFlag && m_pPlayer->IsAliving() )
		{
			if ( (m_nAtbFrameCount / 6) % 4 == 0 )
				m_nState = BK_STAND;
			else if ( (m_nAtbFrameCount / 6) % 4 == 1 )
				m_nState = BK_WALK_R;
			else if ( (m_nAtbFrameCount / 6) % 4 == 2 )
				m_nState = BK_STAND;
			else
				m_nState = BK_WALK_L;
		}
		return;
	}

	// Aj[V
	m_nAniFrameCount --;	// Aj[VJE^ (fNg)

	switch ( m_nAnimationPtrn )
	{
	case ANI_PTN_NONE:			// Aj[V
		m_nDrawOffsetX = 0;
		m_nDrawOffsetY = 0;
		break;

	case ANI_PTN_WALK_AT_START:	// Jns

		if ( m_nAniFrameCount % 2 == 0)
			m_nDrawOffsetX -= 4;

		if ( (m_nAniFrameCount / 2) % 4 == 0 )
			m_nState = STAND;
		else if ( (m_nAniFrameCount / 2) % 4 == 1 )
			m_nState = WALK_R;
		else if ( (m_nAniFrameCount / 2) % 4 == 2 )
			m_nState = STAND;
		else
			m_nState = WALK_L;
		break;

	case ANI_PTN_ATTACK:		// U
		if ( 20 <= m_nAniFrameCount )
		{	// 20t[Oɕ
			if ( m_nAniFrameCount % 2 == 0)
				m_nDrawOffsetX -= 4;

			if ( (m_nAniFrameCount / 2) % 4 == 0 )
				m_nState = STAND;
			else if ( (m_nAniFrameCount / 2) % 4 == 1 )
				m_nState = WALK_R;
			else if ( (m_nAniFrameCount / 2) % 4 == 2 )
				m_nState = STAND;
			else
				m_nState = WALK_L;
			break;
		}
		else 
		{	// 20t[U[V
			if ( m_nAniFrameCount % 20  < 10 )
				m_nState = ATACK_02;
			else
				m_nState = ATACK_01;
		}
		break;
	case ANI_PTN_ATTACK_BACK:	// 20t[ジ
		if ( m_nAniFrameCount % 2 == 0)
			m_nDrawOffsetX += 4;

		if ( (m_nAniFrameCount / 2) % 4 == 0 )
			m_nState = BK_STAND;
		else if ( (m_nAniFrameCount / 2) % 4 == 1 )
			m_nState = BK_WALK_R;
		else if ( (m_nAniFrameCount / 2) % 4 == 2 )
			m_nState = BK_STAND;
		else
			m_nState = BK_WALK_L;
		break;

	case ANI_PTN_DAMAGE:		// _[W
		m_nState = DAMAGE;
		if ( 12 < m_nAniFrameCount )
			m_nDrawOffsetX = 4;
		else if ( 6 < m_nAniFrameCount )
			m_nDrawOffsetX = 0;
		else
			m_nDrawOffsetX = 2;

		break;
	case ANI_PTN_WIN_JUMP:		// 퓬̃oUC
		if ( m_nAniFrameCount % 40 < 20 )
			m_nState = HANDS_UP;
		else
			m_nState = STAND;
		break;

	case ANI_PTN_RUNAWAY:		// 鐬
		if ( m_nAniFrameCount % 2 == 0)
			m_nDrawOffsetX += 4;

		if ( (m_nAniFrameCount / 2) % 4 == 0 )
			m_nState = BK_STAND;
		else if ( (m_nAniFrameCount / 2) % 4 == 1 )
			m_nState = BK_WALK_R;
		else if ( (m_nAniFrameCount / 2) % 4 == 2 )
			m_nState = BK_STAND;
		else
			m_nState = BK_WALK_L;
		break;
	}

	// ŏIt[Œ~
	if ( m_nAniFrameCount == 0 )
	{
		StopAnimation();
	}

}
//-----------------------------------------------------------------------------
// StopAnimation
//-----------------------------------------------------------------------------
void CPlayerBattle::StopAnimation( void )
{
	if ( m_nAnimationPtrn != ANI_PTN_RUNAWAY )
	{
		m_nDrawOffsetX = 0;
		m_nDrawOffsetY = 0;
	}
	m_nAnimationPtrn = ANI_PTN_NONE;
	m_nState = STAND;

	// s҂`FbN && h䒆`FbN
	if ( IsWaitingAction() || m_pPlayer->m_Status.bGuard )
	{
		m_nState = WAIT;
	}
	// S`FbN
	if ( m_pPlayer->m_CharInfo.nHP <= 0 )
	{
		m_nState = DEAD;
	}
}
//-----------------------------------------------------------------------------
// SetWaitAction
//-----------------------------------------------------------------------------
void CPlayerBattle::SetWaitAction( BOOL bFlag )
{
	m_bWaitAction = bFlag;
	//LOG_OUTPUT("[%s] WaitAction [%d]\n", m_pPlayer->m_CharInfo.szName, m_bWaitAction );
};
//-----------------------------------------------------------------------------
// StartAction
//-----------------------------------------------------------------------------
void CPlayerBattle::StartAction( int nAniPtnNo )
{
	if ( !m_pPlayer->IsAliving() )
		return;	// łAj[VȂ

	m_nAnimationPtrn = nAniPtnNo;
	m_nDrawOffsetX = 0;
	m_nDrawOffsetY = 0;

	switch ( m_nAnimationPtrn )
	{
	case ANI_PTN_WALK_AT_START:	// Jns
		m_nAniFrameCount = 24;
		m_nDrawOffsetX = 48;
		break;
	case ANI_PTN_ATTACK:		// 
		m_nAniFrameCount = 40;
		break;
	case ANI_PTN_ATTACK_BACK:	// ŨobN
		m_nDrawOffsetX = -40;
		m_nAniFrameCount = 20;
		break;
	case ANI_PTN_DAMAGE:		// _[W
		m_nDrawOffsetX	 = 4;
		m_nAniFrameCount = 18;
		break;

	case ANI_PTN_WIN_JUMP:		// 퓬̃Wv
		m_nAniFrameCount = 0xFFFFFFFF;	// [
		break;

	case ANI_PTN_RUNAWAY:		// 鐬
		m_nAniFrameCount = 64;
		break;

	default:
		break;
	}
	
}
//-----------------------------------------------------------------------------
// Render
//-----------------------------------------------------------------------------
void CPlayerBattle::Render( void )
{
	DrawGraph( m_nPosX + m_nDrawOffsetX, m_nPosY + m_nDrawOffsetY, m_nHandle[m_nState], TRUE );

	m_NumAnime.Render();	// lAj[V
}
//-----------------------------------------------------------------------------
// RenderPortrait
// G`悷
//-----------------------------------------------------------------------------
void CPlayerBattle::RenderPortrait( int nPosX, int nPosY )
{
	RenderPortrait( nPosX, nPosY, STAND );
}
//-----------------------------------------------------------------------------
// RenderPortrait
// G`悷
//-----------------------------------------------------------------------------
void CPlayerBattle::RenderPortrait( int nPosX, int nPosY, int nState )
{
	DrawGraphEx( nPosX, nPosY, m_nHandle[ nState ], TRUE ) ;
}
//-----------------------------------------------------------------------------
// IncreaseATBValue
//-----------------------------------------------------------------------------
int CPlayerBattle::IncreaseATBValue( int nValue )
{
	int nRetValue = nValue;

	int nPlayerATBSpeed = CSysDebug::GetDebugParam( "Battle", "PlayerATBSpeed", 0 );

	int nRate;
	if ( nPlayerATBSpeed == 1 )
	{	// 
		nRate = 10;
	}
	else if ( nPlayerATBSpeed == 2 )
	{	// ͂₢
		nRate = 2;
	}
	else if ( nPlayerATBSpeed == 3 || nPlayerATBSpeed == 4 )
	{	//  / 
		nRate = 1;
	}
	else
	{	// ʏ
		nRate = 6;
	}
	if ( m_nAtbFrameCount % nRate == 0 )
	{
		// Xe[^Xɉ ATBlXV
		if ( nRetValue < ATB_VALUE_MAX )
		{
			++ nRetValue;

			if (  nPlayerATBSpeed == 4 )
			{
				++ nRetValue;
				if ( ATB_VALUE_MAX < nRetValue )
				{
					nRetValue = ATB_VALUE_MAX;
				}
			}
		}
		else
		{
			nRetValue = ATB_VALUE_MAX;
		}
	}

	return nRetValue;
}

//-----------------------------------------------------------------------------
// GetNumAnimeDispPos
// Aj[V\ʒu擾
//-----------------------------------------------------------------------------
void CPlayerBattle::GetNumAnimeDispPos( int *pX, int *pY, int iDispWidth )
{
	*pX = m_nPosX + ((27 - iDispWidth) / 2);
	*pY = m_nPosY + 27 - 12;
}
//-----------------------------------------------------------------------------
// StartNumAnimation
//-----------------------------------------------------------------------------
void CPlayerBattle::StartNumAnimation( int nDiff, DWORD dwColor )
{
	int iX,iY;
	int iWidth = CNumberAnimation::GetDispWidth( nDiff );
	GetNumAnimeDispPos( &iX, &iY, iWidth );
	m_NumAnime.StartAction( iX, iY, nDiff, dwColor );
}
