//=============================================================================
// PlayerChar.cpp
//=============================================================================
#include "Stdinc.h"
#include "PlayerChar.h"
#include "Manipulator.h"
#include "MapManager.h"
#include "Item.h"
#include "DataManager.h"
#include "PlayerParty.h"
#include "Game.h"
//-----------------------------------------------------------------------------
// RXgN^
//-----------------------------------------------------------------------------
CPlayerChar::CPlayerChar(void)
{
	RtlZeroMemory( &m_CharInfo, sizeof(m_CharInfo) );
	RtlZeroMemory( &m_BasePram, sizeof(m_BasePram) );
	RtlZeroMemory( &m_Param,    sizeof(m_Param) );
	RtlZeroMemory( &m_Status,   sizeof(m_Status) );

	RtlZeroMemory( &m_nCommand,   sizeof(m_nCommand) );
}

//-----------------------------------------------------------------------------
// fXgN^
//-----------------------------------------------------------------------------
CPlayerChar::~CPlayerChar(void)
{
}
//-----------------------------------------------------------------------------
// Create
//-----------------------------------------------------------------------------
BOOL CPlayerChar::Create( int nID, int nPicID, CPlayerParty *pParty )
{
	// p[eB|C^ۑ
	m_pParty = pParty;

	// 
	BOOL bRet = CCharacterObject::Create( nID, nPicID );

	// 퓬Gǂݍ
	bRet &= m_Battle.Create( nID, nPicID, this );

	// ʒu
	SetPosTile( SCREEN_CENTER_TILE_X, SCREEN_CENTER_TILE_Y, DIRECTION_U );
	
	int nX, nY;
	CGame::GetInstance()->GetMapMan()->GetCenterPos( &nX, &nY );
	m_nLocY = nX;
	m_nLocX = nY;

	// i
	RtlZeroMemory( m_Equip, sizeof(m_Equip) );

	// Lv1f[^ݒ
	CDataManager::GetInstance()->LoadLvInfoDataCSV( nID, 1, &m_BasePram );
	sprintf_s( m_CharInfo.szName, CDataManager::GetInstance()->GetCharName( nID ) );
	m_CharInfo.nLV = 1;
	m_CharInfo.nJLV = 1;

	CalcParam();	// p^vZ

	RecoveryHPMP();	// HP/MPS

	// R}hXgǂݍ
	// ToDo:
	m_nCommand[0] = COMMAND_ID_ATTACK;
	m_nCommand[1] = COMMAND_ID_NONE;
	m_nCommand[2] = COMMAND_ID_NONE;
	m_nCommand[3] = COMMAND_ID_ITEM;

	return bRet;
}
//-----------------------------------------------------------------------------
// Delete
//-----------------------------------------------------------------------------
void CPlayerChar::Delete( void )
{
	CCharacterObject::Delete();

	m_Battle.Delete();

}
//-----------------------------------------------------------------------------
// XV
//-----------------------------------------------------------------------------
void CPlayerChar::FrameMove( const CManipulator *pMani, CMapManager *pMapMan  )
{
	CCharacterObject::FrameMove();

	if ( !pMapMan->IsScrolling() )
	{
		// 
		if ( pMani->IsKeyPushed( KEY_INPUT_UP ) )
		{
			m_nDirection = DIRECTION_U;
		}
		else if ( pMani->IsKeyPushed( KEY_INPUT_DOWN ) )
		{
			m_nDirection = DIRECTION_D;
		}
		else if ( pMani->IsKeyPushed( KEY_INPUT_LEFT ) )
		{
			m_nDirection = DIRECTION_L;
		}
		else if ( pMani->IsKeyPushed( KEY_INPUT_RIGHT ) )
		{
			m_nDirection = DIRECTION_R;
		}

		// {^
		if ( pMani->CheckKey( KEY_INPUT_X ) )
		{
			// Ă
			pMapMan->NotifyDecideKey( m_nDirection );
		}

	}
	// sAj (ToDo: 蕨̎lȂ)
	pMapMan->GetCenterPos( &m_nLocX, &m_nLocY );
	m_nState = CalcState( abs(pMapMan->GetScrollOffset()), m_nLocX, m_nLocY );

}
//-----------------------------------------------------------------------------
// L[`FbNȂXV
//-----------------------------------------------------------------------------
void CPlayerChar::FrameMove( CMapManager *pMapMan )
{
	// sAj (ToDo: 蕨̎lȂ)
	pMapMan->GetCenterPos( &m_nLocX, &m_nLocY );
	m_nState = CalcState( abs(pMapMan->GetScrollOffset()), m_nLocX, m_nLocY );
}

//-----------------------------------------------------------------------------
// ͂
//-----------------------------------------------------------------------------
void CPlayerChar::RemoveEquipItem( int nChrPos )
{
	// Ă̂̂
	if ( m_Equip[nChrPos].nID != 0 )
	{
		m_pParty->AddItem( m_Equip[nChrPos].nID );
	}

	RtlZeroMemory( &m_Equip[nChrPos], sizeof(m_Equip[nChrPos]) );
}
//-----------------------------------------------------------------------------
// 
//-----------------------------------------------------------------------------
BOOL CPlayerChar::SetEquipItem( CEquipItem *pEquip, int nChrPos )
{
	if ( !pEquip )
	{	// ͂
		RemoveEquipItem( nChrPos );
		return TRUE;
	}

	int nSetTo = nChrPos;
	if ( nChrPos == CHR_POS_MAX )
	{
		nSetTo = CEquipItem::GetCharPosFromEquipPos( pEquip->nEquipPos );
	}

	// ێ
	m_Equip[nSetTo] = *pEquip;
	//LOG_OUTPUT("[%s]𑕔\n", m_Equip[nSetTo].szName );

	// ACe񂩂͍폜
	m_pParty->RemoveItem( pEquip->nID );

	return TRUE;
}
//-----------------------------------------------------------------------------
// 𑕔Ă邩
//-----------------------------------------------------------------------------
BOOL CPlayerChar::IsNoWeapon( void )
{
	switch( m_Equip[CHR_POS_DOMINANT].nType )
	{
		case EQUIP_ITEM_TYPE_SHORT_SWORD:	// Z
		case EQUIP_ITEM_TYPE_LONG_SWORD:		// 
		case EQUIP_ITEM_TYPE_WAND:			// 
		case EQUIP_ITEM_TYPE_ROD:			// bh
			return FALSE;
	}
	switch( m_Equip[CHR_POS_NON_DOMINANT].nType )
	{
		case EQUIP_ITEM_TYPE_SHORT_SWORD:	// Z
		case EQUIP_ITEM_TYPE_LONG_SWORD:		// 
		case EQUIP_ITEM_TYPE_WAND:			// 
		case EQUIP_ITEM_TYPE_ROD:			// bh
			return FALSE;
	}

	return TRUE;
}
//-----------------------------------------------------------------------------
// CalcParam
// x[Xp^Ƒip^vZ
//-----------------------------------------------------------------------------
void CPlayerChar::CalcParam( void )
{
	ZeroMemory( &m_Param, sizeof(m_Param) );

	//  bp^
	// f̊bp^
	m_Param.Base = m_BasePram;
	for ( int iCnt = 0; iCnt < CHR_POS_MAX; iCnt ++ )
	{	// ł̃u[Xg
		if ( m_Equip[iCnt].nID == 0 )
			continue;	// 

		// x[Xp^
		m_Param.Base.nMaxHP		+= m_Equip[iCnt].Param.Base.nMaxHP;
		m_Param.Base.nMaxMP		+= m_Equip[iCnt].Param.Base.nMaxMP;
		m_Param.Base.nStrength	+= m_Equip[iCnt].Param.Base.nStrength;
		m_Param.Base.nVitality	+= m_Equip[iCnt].Param.Base.nVitality;
		m_Param.Base.nSpeed		+= m_Equip[iCnt].Param.Base.nSpeed;
		m_Param.Base.nIntellect += m_Equip[iCnt].Param.Base.nIntellect;
		m_Param.Base.nPiety		+= m_Equip[iCnt].Param.Base.nPiety;
		m_Param.Base.nLuck		+= m_Equip[iCnt].Param.Base.nLuck;
	}


	//  p^
	// bp^R
	m_Param.nAttack		= m_Param.Base.nStrength;
	m_Param.nDefence	= m_Param.Base.nVitality;
	m_Param.nMagicDef	= m_Param.Base.nPiety;
	m_Param.nParry		= (int)(m_Param.Base.nLuck * 0.1);
	m_Param.nMagicPar	= m_Param.Base.nPiety + (int)(m_Param.Base.nLuck * 0.1);
	m_Param.nWeight		= 0;	// d 0
	m_Param.nHitRate	= 100;	// 100%

	for ( int iCnt = 0; iCnt < CHR_POS_MAX; iCnt ++ )
	{	// ł̃u[Xg
		if ( m_Equip[iCnt].nID == 0 )
			continue;	// 

		m_Param.nAttack   += m_Equip[iCnt].Param.nAttack;
		m_Param.nDefence  += m_Equip[iCnt].Param.nDefence;
		m_Param.nMagicDef += m_Equip[iCnt].Param.nMagicDef;
		m_Param.nParry	  += m_Equip[iCnt].Param.nParry;
		m_Param.nMagicPar += m_Equip[iCnt].Param.nMagicPar;
		m_Param.nWeight	  += m_Equip[iCnt].Param.nWeight;

		double dblRate = (double)m_Param.nHitRate / 100;
		dblRate *= ((double)m_Equip[iCnt].Param.nHitRate / 100);
		m_Param.nHitRate = (int)dblRate * 100;
	}
}
//-----------------------------------------------------------------------------
// CalcParam
//-----------------------------------------------------------------------------
void CPlayerChar::CalcParam( PARAM *pParam, CEquipItem *pEquip, int nCharPos ) const
{

	ZeroMemory(pParam, sizeof(PARAM) );

	//  bp^
	// f̊bp^
	pParam->Base = m_BasePram;
	for ( int iCnt = 0; iCnt < CHR_POS_MAX; iCnt ++ )
	{	// ł̃u[Xg

		// x[Xp^
		if ( iCnt == nCharPos  )
		{
			if ( !pEquip )
				continue;	// 

			pParam->Base.nMaxHP		+= pEquip->Param.Base.nMaxHP;
			pParam->Base.nMaxMP		+= pEquip->Param.Base.nMaxMP;
			pParam->Base.nStrength	+= pEquip->Param.Base.nStrength;
			pParam->Base.nVitality	+= pEquip->Param.Base.nVitality;
			pParam->Base.nSpeed		+= pEquip->Param.Base.nSpeed;
			pParam->Base.nIntellect += pEquip->Param.Base.nIntellect;
			pParam->Base.nPiety		+= pEquip->Param.Base.nPiety;
			pParam->Base.nLuck		+= pEquip->Param.Base.nLuck;
		}
		else
		{
			if ( m_Equip[iCnt].nID == 0 )
				continue;	// 
			pParam->Base.nMaxHP		+= m_Equip[iCnt].Param.Base.nMaxHP;
			pParam->Base.nMaxMP		+= m_Equip[iCnt].Param.Base.nMaxMP;
			pParam->Base.nStrength	+= m_Equip[iCnt].Param.Base.nStrength;
			pParam->Base.nVitality	+= m_Equip[iCnt].Param.Base.nVitality;
			pParam->Base.nSpeed		+= m_Equip[iCnt].Param.Base.nSpeed;
			pParam->Base.nIntellect += m_Equip[iCnt].Param.Base.nIntellect;
			pParam->Base.nPiety		+= m_Equip[iCnt].Param.Base.nPiety;
			pParam->Base.nLuck		+= m_Equip[iCnt].Param.Base.nLuck;
		}
	}


	//  p^
	// bp^R
	pParam->nAttack		= pParam->Base.nStrength;
	pParam->nDefence	= pParam->Base.nVitality;
	pParam->nMagicDef	= pParam->Base.nPiety;
	pParam->nParry		= (int)(pParam->Base.nLuck * 0.1);
	pParam->nMagicPar	= pParam->Base.nPiety + (int)(pParam->Base.nLuck * 0.1);
	pParam->nWeight		= 0;	// d 0
	pParam->nHitRate	= 100;	// 100%

	for ( int iCnt = 0; iCnt < CHR_POS_MAX; iCnt ++ )
	{	// ł̃u[Xg

		if ( iCnt == nCharPos )
		{
			if ( !pEquip )
				continue;	// 

			pParam->nAttack   += pEquip->Param.nAttack;
			pParam->nDefence  += pEquip->Param.nDefence;
			pParam->nMagicDef += pEquip->Param.nMagicDef;
			pParam->nParry	  += pEquip->Param.nParry;
			pParam->nMagicPar += pEquip->Param.nMagicPar;
			pParam->nWeight	  += pEquip->Param.nWeight;

			double dblRate = (double)pParam->nHitRate / 100;
			dblRate *= ((double)pEquip->Param.nHitRate / 100);
			pParam->nHitRate = (int)dblRate * 100;
		}
		else
		{
			if ( m_Equip[iCnt].nID == 0 )
				continue;	// 

			pParam->nAttack   += m_Equip[iCnt].Param.nAttack;
			pParam->nDefence  += m_Equip[iCnt].Param.nDefence;
			pParam->nMagicDef += m_Equip[iCnt].Param.nMagicDef;
			pParam->nParry	  += m_Equip[iCnt].Param.nParry;
			pParam->nMagicPar += m_Equip[iCnt].Param.nMagicPar;
			pParam->nWeight	  += m_Equip[iCnt].Param.nWeight;

			double dblRate = (double)pParam->nHitRate / 100;
			dblRate *= ((double)m_Equip[iCnt].Param.nHitRate / 100);
			pParam->nHitRate = (int)dblRate * 100;
		}
	}
}
//-----------------------------------------------------------------------------
// ʒu
//-----------------------------------------------------------------------------
void CPlayerChar::SetBattlePos( int nPosX, int nPosY )
{
	m_Battle.SetPos( nPosX, nPosY );
}
//-----------------------------------------------------------------------------
// XV
//-----------------------------------------------------------------------------
void CPlayerChar::FrameMoveAtBattle( void )
{
	m_Battle.FrameMove();
}
//-----------------------------------------------------------------------------
// `
//-----------------------------------------------------------------------------
void CPlayerChar::RenderAtBattle( void )
{
	m_Battle.Render();
}
//-----------------------------------------------------------------------------
// G` STANDŒ
//-----------------------------------------------------------------------------
void CPlayerChar::RenderPortrait( int nPosX, int nPosY )
{
	RenderPortrait( nPosX, nPosY, CPlayerBattle::STAND );
}
//-----------------------------------------------------------------------------
// G`
//-----------------------------------------------------------------------------
void CPlayerChar::RenderPortrait( int nPosX, int nPosY, int nState )
{
	m_Battle.RenderPortrait( nPosX, nPosY, nState );
}
//-----------------------------------------------------------------------------
// ATBlXV
//-----------------------------------------------------------------------------
void CPlayerChar::IncreaseATBValue( void )
{
	m_CharInfo.nAtbValue = m_Battle.IncreaseATBValue( m_CharInfo.nAtbValue );
}

//-----------------------------------------------------------------------------
// 퓬ANVJn
//-----------------------------------------------------------------------------
void CPlayerChar::StartBattleAction( int nAniPtnNo )
{
	m_Battle.StartAction( nAniPtnNo );
}
//-----------------------------------------------------------------------------
// ChangeHitPoint
// HP
//-----------------------------------------------------------------------------
void CPlayerChar::ChangeHitPoint( int iDiff )
{
	if ( m_CharInfo.nHP == 0 && iDiff < 0 )
	{
		// 퓬s\ɉ񕜂͂łȂ
		return;
	}

	// 퓬
	if ( CGame::GetInstance()->GetMode() == MODE_BATTLE )
	{
		// HPAj[Vݒ
		DWORD dwColor;
		if ( 0 <= iDiff )
		{	// 0Ɛ̒l
			dwColor = GetColor(255,255,255);
		}
		else
		{	// ̒l(HP)
			dwColor = GetColor(96,255,96);
		}

		m_Battle.StartNumAnimation( abs(iDiff), dwColor );
		// _[WAj[V
		StartBattleAction( CPlayerBattle::ANI_PTN_DAMAGE );
	}

	// HP
	m_CharInfo.nHP -= iDiff;
	if ( m_CharInfo.nHP <= 0 )
	{
		m_CharInfo.nHP = 0;
		m_Battle.SetState( CPlayerBattle::DEAD );
	}
	if ( m_Param.Base.nMaxHP < m_CharInfo.nHP )
	{
		m_CharInfo.nHP = m_Param.Base.nMaxHP;
	}

}
//-----------------------------------------------------------------------------
// ChangeMagicPoint
// MP
//-----------------------------------------------------------------------------
void CPlayerChar::ChangeMagicPoint( int iDiff )
{
	// 퓬
	if ( CGame::GetInstance()->GetMode() == MODE_BATTLE )
	{
		// ToDo:
	}

	// MP
	m_CharInfo.nMP -= iDiff;
	if ( m_CharInfo.nMP <= 0 )
	{
		m_CharInfo.nMP = 0;
	}
	if ( m_Param.Base.nMaxMP < m_CharInfo.nMP )
	{
		m_CharInfo.nMP = m_Param.Base.nMaxMP;
	}

}
//-----------------------------------------------------------------------------
// Exp
// LvUp TRUEԂ
//-----------------------------------------------------------------------------
BOOL CPlayerChar::AddExp( int nExp )
{
	// őLv͉̎Ȃ
	if ( m_CharInfo.nLV == MAX_LV )
		return FALSE;

	// olǉ
	m_CharInfo.nExp += nExp;
	if ( MAX_EXP < m_CharInfo.nExp )
		m_CharInfo.nExp = MAX_EXP;

	// LvɕKvȌol
	int nNextExp = CDataManager::GetInstance()->GetToNextLvCSV( m_nID, m_CharInfo.nLV, m_CharInfo.nExp );
	if ( nNextExp <= 0 )
	{
		LOG_OUTPUT("[%s] LvAbv [%d]  [%d]\n",m_CharInfo.szName, m_CharInfo.nLV, m_CharInfo.nLV+1 );
		m_CharInfo.nLV ++;	// LvAbv

		// p[^ǂݍ
		CDataManager::GetInstance()->LoadLvInfoDataCSV( m_nID, m_CharInfo.nLV, &m_BasePram );
		CalcParam();	// p^vZ

		// グ
		while ( AddExp( 0 ) ){};

		return TRUE;
	}

	return FALSE;
}

//-----------------------------------------------------------------------------
// ABP
// Job LvUp TRUEԂ
//-----------------------------------------------------------------------------
BOOL CPlayerChar::AddABP( int nABP )
{
	return FALSE;
}