//=============================================================================
// StoreAmountWindow.cpp
//=============================================================================
#include "Stdinc.h"
#include "StoreAmountWindow.h"
#include "StoreWindow.h"
#include "Item.h"
#include "Manipulator.h"
#include "Game.h"
#include "PlayerParty.h"
//-----------------------------------------------------------------------------
// RXgN^
//-----------------------------------------------------------------------------
CStoreAmountWindow::CStoreAmountWindow(void)
	:m_nCount ( 1 )
{
}

//-----------------------------------------------------------------------------
// fXgN^
//-----------------------------------------------------------------------------
CStoreAmountWindow::~CStoreAmountWindow(void)
{
}
//-----------------------------------------------------------------------------
// Create
//-----------------------------------------------------------------------------
BOOL CStoreAmountWindow::Create( int iPosX, int iPosY, int iWidth, int iHeight, CPlayerParty *pParty, CStoreWindow *pParent )
{
	m_pParent = pParent;		// eۑ
	m_pPlayerParty = pParty;

	return CMenuWindow::Create( iPosX, iPosY, iWidth, iHeight );
}
//-----------------------------------------------------------------------------
// FrameMove
//-----------------------------------------------------------------------------
void CStoreAmountWindow::FrameMove( const CManipulator *pMani )
{
	if ( !m_bFocused && !IsVisible() )
		return;

	CMenuWindow::FrameMove( pMani );

	// L[
	if ( pMani->CheckKey( KEY_INPUT_UP ) )
	{
		m_nCount += 10;
	}
	// L[
	else if ( pMani->CheckKey( KEY_INPUT_DOWN ) )
	{
		m_nCount -= 10;
	}
	// L[
	else if ( pMani->CheckKey( KEY_INPUT_LEFT ) )
	{
		m_nCount --;
	}
	// EL[
	else if ( pMani->CheckKey( KEY_INPUT_RIGHT ) )
	{
		m_nCount ++;
	}

	//  
	if ( m_nMode == MODE_BUY )
	{
		//  őŏl
		if ( m_nCount <= 0 )
		{	m_nCount = 1;	}
		if ( 99 < m_nCount + m_nHavingCount )
		{	m_nCount = 99 - m_nHavingCount;	}

		// ̐
		UINT nValue = (UINT)(m_pItem->nValue * ((double)m_nRate / 100.0 ));
		if ( m_pPlayerParty->GetGill() < nValue * m_nCount )
		{	// ő܂
			m_nCount = (int)((double)m_pPlayerParty->GetGill() / nValue ); 
		}
	}
	else
	{
		//  őŏl
		if ( m_nCount <= 0 )
		{	m_nCount = 1;	}
		if ( m_nHavingCount < m_nCount )
		{	m_nCount = m_nHavingCount;	}
	}

	// LZL[
	if ( pMani->CheckKey( KEY_INPUT_Z ) )
	{
		m_pParent->NotifyCancelKey( this );
	}
	// L[
	else if ( pMani->CheckKey( KEY_INPUT_X ) )
	{
		if ( !m_bFocused )
			return;
		m_pParent->NotifyDecideKey( this, GetCurPos() );
	}
}
//-----------------------------------------------------------------------------
// `
//-----------------------------------------------------------------------------
void CStoreAmountWindow::Render( void )
{
	if ( !IsVisible() )
		return;

	//CMenuWindow::Render();
	CFrameWindow::Render();

	if ( !m_pItem )
	{
		assert( 0 );
		return;
	}

	char szBuff[64];

	// ACe`
	stMenuItem *pMenuItem = GetItem( 0 );

	// O
	DrawString( m_nPosX + pMenuItem->nPosX, m_nPosY + pMenuItem->nPosY, m_pItem->szName, STRING_COLOR );

	// 
	sprintf_s( szBuff, sizeof(szBuff) , "F %2d" , m_nCount );
	DrawString( m_nPosX + pMenuItem->nPosX + 99, m_nPosY + pMenuItem->nPosY, szBuff, STRING_COLOR );

	// vz
	UINT nValue = (UINT)(m_pItem->nValue * ((double)m_nRate / 100.0 ));
	if ( m_nMode == MODE_SELL )
	{//  
		nValue /= 2;
	}
	sprintf_s( szBuff, sizeof(szBuff) , "c %6dM" ,nValue * m_nCount );
	DrawString( m_nPosX + pMenuItem->nPosX + 129, m_nPosY + pMenuItem->nPosY, szBuff, STRING_COLOR );

	// Ă鐔
	sprintf_s( szBuff, sizeof(szBuff) , "Ă邩@@F %2d" , m_nHavingCount );
	DrawString( m_nPosX + pMenuItem->nPosX, m_nPosY + pMenuItem->nPosY + 20, szBuff, STRING_COLOR );

	// Ă鐔
	sprintf_s( szBuff, sizeof(szBuff) , "тĂ邩F %2d" , m_nEquipCount );
	DrawString( m_nPosX + pMenuItem->nPosX, m_nPosY + pMenuItem->nPosY + 40, szBuff, STRING_COLOR );

	// J[\`
	if ( m_bFocused  )
	{
		m_pCursor->Render();
	}

}

//-----------------------------------------------------------------------------
// SetTargetItem
//-----------------------------------------------------------------------------
void CStoreAmountWindow::SetTargetItem( int nMode, CItem *pItem, int nRate )
{
	if ( !pItem )
		return;

	m_nMode = nMode;
	m_pItem = pItem;
	m_nRate = nRate;

	ClearMenuItem();

	// j[ACeǉ
	stMenuItem Item;
	Item.nID = 0;
	Item.bEnabled = TRUE;

	// ʒu
	Item.nPosX = 30;
	Item.nPosY = 10;
	Item.lpzText = pItem->szName;
	Item.nIcon = 0;
	Item.nCount = 1;

	AddMenuItem( &Item );
	SetCurPos( 0 );

	// ƂĂ鐔
	m_nCount = 1;

	// Ă鐔
	m_nHavingCount = m_pPlayerParty->GetItemCount( m_pItem->nID );

	// Ă鐔
	m_nEquipCount  = m_pPlayerParty->GetEquipCount( m_pItem->nID );

}
