//=============================================================================
// StoreMenuWindow.cpp
//=============================================================================
#include "Stdinc.h"
#include "StoreMenuWindow.h"
#include "CoWndManager.h"
#include "Manipulator.h"


const stMenuItem ITEM_MENU_ITEM[] = {
	{   CStoreMenuWindow::MENU_ID_BUY,	TRUE,  20,   8, "", 0, 0 },
	{   CStoreMenuWindow::MENU_ID_SELL,	TRUE,  70,   8, "", 0, 0 },
	{   CStoreMenuWindow::MENU_ID_EXIT,	TRUE, 120,   8, "ł", 0, 0 },
};

//-----------------------------------------------------------------------------
// RXgN^
//-----------------------------------------------------------------------------
CStoreMenuWindow::CStoreMenuWindow(void)
{
	m_nType = MENU_TYPE_HORIZONTAL;	// ^j[
}
//-----------------------------------------------------------------------------
// fXgN^
//-----------------------------------------------------------------------------
CStoreMenuWindow::~CStoreMenuWindow(void)
{
}

//-----------------------------------------------------------------------------
// Create
//-----------------------------------------------------------------------------
BOOL CStoreMenuWindow::Create( int iPosX, int iPosY, int iWidth, int iHeight, CCoWndManager *pParent )
{
	// eEBhEۑ
	m_pParent = pParent;

	BOOL bRet = CMenuWindow::Create( iPosX, iPosY, iWidth, iHeight );

	// ACeǉ
	for ( int iCnt = 0; iCnt < sizeof( ITEM_MENU_ITEM ) / sizeof( ITEM_MENU_ITEM[0] ); iCnt ++ )
	{
		AddMenuItem( &ITEM_MENU_ITEM[iCnt] );
	}
	return bRet;
}

//-----------------------------------------------------------------------------
// `
//-----------------------------------------------------------------------------
void CStoreMenuWindow::Render( void )
{
	CMenuWindow::Render();

	// J[\`
	if ( m_bFocused  )
	{
		m_pCursor->Render();
	}
}
//-----------------------------------------------------------------------------
// XV
//-----------------------------------------------------------------------------
void CStoreMenuWindow::FrameMove( const CManipulator *pMani )
{
	if ( !m_bFocused )
		return;

	CMenuWindow::FrameMove( pMani );

	// LZL[
	if ( pMani->CheckKey( KEY_INPUT_Z ) )
	{
		m_pParent->NotifyCancelKey( this );
	}
	else if ( pMani->CheckKey( KEY_INPUT_X ) )
	{
		m_pParent->NotifyDecideKey( this, GetCurPos() );
	}
}
