//=============================================================================
// SysUtil.cpp
//=============================================================================
#include "Stdinc.h"
#include "SysUtil.h"

void CSysUtil::Halt(const char *inputMsg,...) {
	int len;
	char buf[256];
	va_list ap;
	va_start(ap,inputMsg);
	len = vsprintf_s(buf,128,inputMsg,ap);
	va_end(ap);
	if(len!=EOF) {
		int EM = MessageBox(	GetMainWindowHandle(),
								buf,
								"ERROR",
								MB_OK|MB_ICONSTOP);
	}
	DxLib_End();
	exit(-1);
}
/* G[2iIȂj */
void CSysUtil::Msg(const char *inputMsg,...) {
	int len;
	char buf[1024];
	va_list ap;
	va_start(ap,inputMsg);
	len = vsprintf_s(buf,sizeof(buf),inputMsg,ap);
	va_end(ap);
	if(len!=EOF) {
		int EM = MessageBox(	GetMainWindowHandle(),
								buf,
								"ERROR",
								MB_OK|MB_ICONSTOP);
	}
}
//-----------------------------------------------------------------------------
// Log
//-----------------------------------------------------------------------------
void CSysDebug::Log( const char *lpzFormat, ... )
{
	
}
//-----------------------------------------------------------------------------
// LuaX^bN_v
//-----------------------------------------------------------------------------
void CSysDebug::printStack(lua_State *L) {

    // X^bN擾
    const int num = lua_gettop(L);
    if (num == 0) {
        LOG_OUTPUT("No stack.\n");
        return;
    }
    for (int i = num; i >= 1; i--) {
        LOG_OUTPUT("%03d(%04d): ", i, -num + i - 1);
        int type = lua_type(L, i);
        switch(type) {
        case LUA_TNIL:
            LOG_OUTPUT("NIL\n");
            break;
        case LUA_TBOOLEAN:
            LOG_OUTPUT("BOOLEAN %s\n", lua_toboolean(L, i) ? "true" : "false");
            break;
        case LUA_TLIGHTUSERDATA:
            LOG_OUTPUT("LIGHTUSERDATA\n");
            break;
        case LUA_TNUMBER:
            LOG_OUTPUT("NUMBER %f\n", lua_tonumber(L, i));
            break;
        case LUA_TSTRING:
            LOG_OUTPUT("STRING %s\n", lua_tostring(L, i));
            break;
        case LUA_TTABLE:
            LOG_OUTPUT("TABLE\n");
            break;
        case LUA_TFUNCTION:
            LOG_OUTPUT("FUNCTION\n");
            break;
        case LUA_TUSERDATA:
            LOG_OUTPUT("USERDATA\n");
            break;
        case LUA_TTHREAD:
            LOG_OUTPUT("THREAD\n");
            break;
        }
    }
    LOG_OUTPUT("-----------------------------\n\n");
}
//-----------------------------------------------------------------------------
// GetActString
//-----------------------------------------------------------------------------
const char *CSysDebug::GetActString( int nActType )
{
	switch( nActType )
	{
	case TIMEKEEP_ACT_TYPE_CMD_INPUT:
		return "v[ R}h";
	case TIMEKEEP_ACT_TYPE_CMD:
		return "v[ R}hs";
		
	case TIMEKEEP_ACT_TYPE_ENEMY_CMD_INPUT:
		return "GR}hI";
	case TIMEKEEP_ACT_TYPE_ENEMY_CMD:
		return "GR}hs";
	default:
		break;
	}

	return "s";
}
//-----------------------------------------------------------------------------
// ANVXg _v
//-----------------------------------------------------------------------------
void CSysDebug::printActionList(std::vector<TIMEKEEP_INFO *> &lstAction)
{
	LOG_OUTPUT("=== ANVXg %d==============\n", lstAction.size() );

	for (int iCnt = 0; iCnt < (int)lstAction.size(); iCnt ++ )
	{
		TIMEKEEP_INFO *pInfo = lstAction.at( iCnt );
		LOG_OUTPUT("[%02d] %s\n" , iCnt, GetActString( pInfo->nActType ) );
		LOG_OUTPUT("    AddFrame [%d]  ExecWaitFrame [%d]\n" , pInfo->nAddFrame, pInfo->nExecWaitFrame );
		LOG_OUTPUT("    nParam1 [%d]  nParam2 [%d]  nParam3 [%d]  nParam4 [%d]\n" , pInfo->nParam1, pInfo->nParam2, pInfo->nParam3, pInfo->nParam4 );
	}

	LOG_OUTPUT("=======================================\n");

}

//-----------------------------------------------------------------------------
// ReplaceString
//-----------------------------------------------------------------------------
void CSysUtil::ReplaceString( char *lpBuff, int nBuffLen, const char *lpzTgt, const char *lpzFind, const char *lpzReplace )
{
    int  i=0, max_a, max_b;
    RtlZeroMemory( lpBuff, nBuffLen );

    // ̍ő啶(p)𒲂ׂ
    max_a = strlen(lpzTgt);
    max_b = strlen(lpzFind);

    for( i = 0; i <= max_a; i++ ){
        if( !strncmp( &lpzTgt[i], lpzFind, max_b ) )
		{
            strcat_s( lpBuff, nBuffLen, lpzReplace );
            i += max_b-1;
        }
        else{
            strncat_s( lpBuff, nBuffLen, &lpzTgt[i], 1 );
        }
    }
}

//-----------------------------------------------------------------------------
// init@Cǂݍ
//-----------------------------------------------------------------------------
int CSysDebug::GetDebugParam( const char *lpzSec,  const char *lpzKey, int nDefault )
{
	const char DEBUG_INI[] = "..\\data\\debug.ini";

	return GetPrivateProfileInt( lpzSec, lpzKey, nDefault, DEBUG_INI );
}
