//=============================================================================
// YesNoMsgWindow.cpp
//=============================================================================
#include "Stdinc.h"
#include "YesNoMsgWindow.h"
#include "Manipulator.h"

const stMenuItem ITEM_YES_NO[] = {
	{   CYesNoMsgWindow::MENU_ID_YES,		TRUE,   10,  40, "͂", 0, 0 },
	{   CYesNoMsgWindow::MENU_ID_NO,		TRUE,   10,  55, "", 0, 0 },
};
//-----------------------------------------------------------------------------
// RXgN^
//-----------------------------------------------------------------------------
CYesNoMsgWindow::CYesNoMsgWindow(void)
	:m_nChooseAns( MENU_ID_YES )
{
	CMenuWindow::m_nType = MENU_TYPE_VERTICAL;	// c^j[
}

//-----------------------------------------------------------------------------
// fXgN^
//-----------------------------------------------------------------------------
CYesNoMsgWindow::~CYesNoMsgWindow(void)
{
}
//-----------------------------------------------------------------------------
// Create
//-----------------------------------------------------------------------------
BOOL CYesNoMsgWindow::Create( int iPosX, int iPosY, int iWidth, int iHeight )
{
	BOOL bRet = CMenuWindow::Create( iPosX, iPosY, iWidth, iHeight );

	// ACeǉ
	for ( int iCnt = 0; iCnt < sizeof( ITEM_YES_NO ) / sizeof( ITEM_YES_NO[0] ); iCnt ++ )
	{
		AddMenuItem( &ITEM_YES_NO[iCnt] );
	}
	return bRet;
}

//-----------------------------------------------------------------------------
// Render
//-----------------------------------------------------------------------------
void CYesNoMsgWindow::Render( void )
{
	if ( !IsVisible() )
		return;

	CMenuWindow::Render();

	// \
	for ( int iCnt = 0; iCnt < QUESTION_MESSAGE_LINE_MAX; iCnt ++ )
	{
		int iPosY = m_nPosY + FRAME_TO_STRING_MARGINE_Y + ( iCnt * (DISPLAY_MESSAGE_FONT_SIZE + 4) );

		DrawString( m_nPosX + FRAME_TO_STRING_MARGINE_X, iPosY, m_szDisplayMsg[iCnt], STRING_COLOR );
	}
}
//-----------------------------------------------------------------------------
// FrameMove
//-----------------------------------------------------------------------------
void CYesNoMsgWindow::FrameMove( const CManipulator *pMani )
{
	if ( !m_bFocused )
		return;

	CMenuWindow::FrameMove( pMani );

	// LZL[
	if ( pMani->CheckKey( KEY_INPUT_Z ) )
	{
		m_nChooseAns = ANSWER_NO;
		SetFocus( FALSE );
		SetVisible( FALSE );
	}
	else if ( pMani->CheckKey( KEY_INPUT_X ) )
	{
		m_nChooseAns = GetCurPos() + 1;
		SetFocus( FALSE );
		SetVisible( FALSE );
	}
}
//-----------------------------------------------------------------------------
// SetVisible
//-----------------------------------------------------------------------------
void CYesNoMsgWindow::SetVisible( BOOL bFlag )
{
	CMenuWindow::SetVisible( bFlag );
	if ( bFlag )
	{
		SetFocus( TRUE );
		SetCurPos( 0 );
	}
}
//-----------------------------------------------------------------------------
// SetQuestionMessage
//-----------------------------------------------------------------------------
void CYesNoMsgWindow::SetQuestionMessage( const char *pMsg )
{
	// bZ[Wۑobt@ɃRs[
	m_nLineCnt = DivCopyToMsgBuf( pMsg );

	// \obt@ɃRs[
	for ( int iCnt = 0; iCnt < QUESTION_MESSAGE_LINE_MAX; iCnt ++ )
	{
		strcpy_s( m_szDisplayMsg[iCnt], _countof(m_szDisplayMsg[iCnt]), m_szMsg[iCnt] );
	}

}

//-----------------------------------------------------------------------------
// CopyWidthLimitString
//-----------------------------------------------------------------------------
int CYesNoMsgWindow::CopyWidthLimitString( char *pDst, const char *pSrc, int nLen )
{
	strncpy_s( pDst, nLen, pSrc, nLen );

	int iStrLen = strlen(pDst);
	for ( int iCnt = iStrLen; 0 < iCnt; iCnt -- )
	{
		int iStrWidth = GetDrawStringWidth( pDst, iStrLen );
		if ( m_nWidth < iStrWidth + FRAME_TO_STRING_MARGINE_X * 2 )
		{	// Eɂ͂ݏoȂ1
			pDst[iCnt] = '\0';
		}
	}

	return 0;
}
//-----------------------------------------------------------------------------
// DivCopyToMsgBuf
//-----------------------------------------------------------------------------
int CYesNoMsgWindow::DivCopyToMsgBuf( const char *pSrc, int nLineCnt /* = 0 */ )
{
	if ( nLineCnt == 0 )
	{
		RtlZeroMemory( m_szMsg, sizeof(m_szMsg) );
	}

	// '\' + 'n' ̕ '\n' ɒu
	char szReplaceBuff[1024];
	CSysUtil::ReplaceString( szReplaceBuff, sizeof(szReplaceBuff), pSrc, "\\n", "\n" );

//	int nLineCnt = 0;
	const char *pStart = szReplaceBuff;
	const char *pPtr = strstr( szReplaceBuff, "\n" );

	while ( pPtr )
	{
		char szBuff[DISPLAY_MESSAGE_LEN_MAX];
		strncpy_s( szBuff, pStart, (size_t)(pPtr - pStart) );

		CopyWidthLimitString( m_szMsg[nLineCnt], szBuff, _countof(m_szMsg[nLineCnt])-1 );

		nLineCnt++;
		pStart = pPtr+1;
		pPtr = strstr( pPtr+1, "\n" );
	}

	CopyWidthLimitString( m_szMsg[nLineCnt], pStart, _countof(m_szMsg[nLineCnt])-1 );

	return nLineCnt+1;
}